<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Task_status_table extends Base_table {

	public $error	= "";

	function __construct()
	{
		parent::__construct(array('tbl'=>'task_status', 'tbl_key'=>'task_status_id'));
	}
	
	public function save($data)
	{
		return parent::save($data);
	}

	public function store_default_data ($data)
	{
		$this->CI->load->database();
		
		if (empty($data['entity_id'])) {
			return false;
		}
		
		$dynamic_data = array(
						'entity_id' 		=> $data['entity_id']
					);
					
		$static_data = array(
							array(
								'name' 				=> 'Open',
								'is_default'		=> '1',
								'system_defined'	=> '1',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#20b717'
							),
							array(
								'name' 				=> 'In Progress',
								'is_default'		=> '0',
								'system_defined'	=> '0',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#2390ff'
							),
							array(
								'name' 				=> 'Need Details',
								'is_default'		=> '0',
								'system_defined'	=> '0',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#fd6c01'
							),
							array(
								'name' 				=> 'Reassigned',
								'is_default'		=> '0',
								'system_defined'	=> '0',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#496100'
							),
							array(
								'name' 				=> 'Review',
								'is_default'		=> '0',
								'system_defined'	=> '0',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#f9f001'
							),
							array(
								'name' 				=> 'Closed',
								'is_default'		=> '0',
								'system_defined'	=> '1',
								'is_closed'			=> '1',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#535352'
							),
							array(
								'name' 				=> 'Hold',
								'is_default'		=> '0',
								'system_defined'	=> '0',
								'is_closed'			=> '0',
								'text_color'		=> '#ffffff',
								'bg_color'			=> '#cdcdcd'
							)
						);
						
		$values = array();
		foreach ($static_data as $val) {
			$values[] = array_merge($val,$dynamic_data);
		}
		return $this->CI->db->insert_batch($this->tbl, $values); 
	}
}
/* end of Task_status_table.php */
