<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Attachment_model extends CI_Model {

	function __construct()
	{
		parent::__construct();
		$this->load->helper("aws");
	}

	public function update_file_path($data)
	{
		if(!empty($data['attachment_id']))
		{
			unset($data['file_name']);
			$this->db->where(array('attachment_id' => $data['attachment_id']));
			$this->db->where("entity_id", $this->ot_app->get('entity_id'));
			$update = $this->db->update('attachment', $data);
			return $update;
		}
	}

	public function get_attachment_details($ids, $module_type, $attachment_id=null)
	{
		$this->db->select('at.attachment_id, at.file_path, at.file_name, at.title, at.file_type, at.file_size, at.module_type, at.module_id, at.posted_by, at.posted_date,u.first_name as posted_by,u.user_image');
		$this->db->from('attachment as at');
		$this->db->join('entity_users as u', 'at.entity_id=u.entity_id and u.user_id=at.posted_by', 'INNER');
		$where = array(
			'at.entity_id'		=> $this->ot_app->get('entity_id'),
			'at.module_type'	=> $module_type,
			'at.module_id'		=> $ids,
		);

		if ($attachment_id)
		{
			$where['at.attachment_id']	= $attachment_id;
		}

		if (is_array($ids))
		{
			unset($where['at.module_id']);
			$this->db->where_in('at.module_id', $ids);
		}
		$this->db->where($where);
		
		$reply_query  = $this->db->get();
      	$result = $reply_query->result_array();

      	$this->load->model('user');

		if ($result) {
		  	foreach($result as $key=>$val) {
		  		// $user_data = $this->user->get_user_data($result[$key]['posted_by']);
		  		// $result[$key]['posted_by'] = isset($user_data['first_name'])? $user_data['first_name'] : $result[$key]['posted_by'];
		  		$result[$key]['encrypt_key'] = base64_encode($val['attachment_id'].'-'.$this->session->userdata('session_id')); 
		  	}
		}
      	return $result;
	}

	public function get_attachment_file($attachment_id)
	{
		$this->db->select('*');
		$this->db->from('attachment');
		$this->db->where("entity_id", $this->ot_app->get('entity_id'));
		$this->db->where('attachment_id',$attachment_id);
		$query = $this->db->get();
		return $query->row_array();
	}

	public function get_attachment_count($module_id)
	{
		$this->db->where("entity_id", $this->ot_app->get('entity_id'));
		$this->db->where("module_type", "T");
		$this->db->where("module_id", $module_id);

		return $this->db->count_all_results("attachment");
	}

	public function delete_attachment($options) 
	{
		$this->db->select('file_path, file_type');
		$this->db->from('attachment');
		$this->db->where("entity_id", $this->ot_app->get('entity_id'));

		foreach($options as $key=>$value)
		{
			if(!empty($value))
				$this->db->where($key, $value);
		}

		$query	= $this->db->get();
		$result	= $query->result_array();

		foreach($options as $key=>$value)
		{
			if(!empty($value))
				$this->db->where($key, $value);
		}

		if($this->db->delete('attachment') && !empty($result))
		{
			foreach($result as $key=>$value)
			{
				$file 		= explode('.', $value['file_path']);
// 				$file_name 	= $file[0] . '.' . $value['file_type'];
				$file_name 	= $file[0] . '.opt';

				$source_file	= "uploads/" . $this->ot_app->get('entity_id') . '/files/' . $file_name;
				@unlink($source_file);

				delete_on_aws_s3($source_file);
			}

			return true;
		}
	}
}

/* End of file mod.invoice.php */
