<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(APPPATH . '/models/timesheets/mod.timesheets_member.php');

class Timesheets_pm extends Timesheets_member
{
	public $error	= '';

	protected $entity_id	= 0;

	function __construct()
	{
		parent::__construct();
		$this->load->library(OTBASE_PATH.'OT_App');
        $this->load->library(OTBASE_PATH.'OT_User');
        $this->entity_id	= $this->ot_app->get('entity_id');
	}
	
	public function save($data)
	{
		
		$this->load->library('time_sheet_table');
		
		$this->time_sheet_table->tbl		=	'time_sheet';
        $this->time_sheet_table->tbl_key	=	'time_sheet_id';

		$params = array();
		if (!empty($data[$this->time_sheet_table->tbl_key]))
		{
			$params['where'] = array('user_id' => $data['user_id'], 'invoice_id' => 0);
			}
		
		$data['last_updated_by'] 	= $this->ot_user->get('user_id');
		$data['last_updated_date'] 	= $this->auth->get_timezone_date('Y-m-d H:i:s');
		
		return $this->time_sheet_table->save($data, $params); 
	}
	
	public function change_status ($data)
	{
		// submit for approval
		if (!empty($data['type']) && !empty($data['time_sheet_id']))
		{
			$this->db->where(array('entity_id' => $this->entity_id, 'approval_status != ' => 'A', 'is_progress' => 0));
			if (is_array($data['time_sheet_id']))
			{
				$this->db->where_in('time_sheet_id', $data['time_sheet_id']);
			}
			else
			{
				$this->db->where('time_sheet_id', $data['time_sheet_id']);
			}
			$this->db->update('time_sheet', array('approval_status' => ($data['type']='approve'?'A':''), 'Last_updated_by' => $this->ot_user->get('user_id'), 'last_updated_date' => $this->auth->get_timezone_date('','UTC')));
			
			$this->response->success();
			return true;
		}		

		return false;
	}
	
	public function start_time_sheet ($data)
	{
		$time_sheet_id = !empty($data['time_sheet_id'])?$data['time_sheet_id']:0;
		
		if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d', true)))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}
				
		// start job
		if ($time_sheet_id)
		{
			// check timesheet date
			$query = $this->db->get_where('time_sheet', array('entity_id' => $this->entity_id, 'time_sheet_id' => $time_sheet_id));
			$sheet = $query->row_array();

			if (empty($sheet))
			{
				$this->response->error('TIMESHEET_NOT_FOUND');
				return false;
			}

			if ($sheet['invoice_id'] || strtotime(date('Y-m-d', strtotime($sheet['entry_date'])))<strtotime($this->auth->get_timezone_date('Y-m-d', true)))
			{
				$sheet['time_sheet_id'] = 0;
				$sheet['hours'] = 0;
				$sheet['invoice_id'] = 0;
				unset($sheet['last_updated_by']);
				unset($sheet['last_updated_date']);
				$sheet['entry_date'] = $data['cur_date'];
				if (!$result =  $this->save($sheet))
				{
					return $result;
					return false;
				}
				
				$time_sheet_id = $result['time_sheet_id'];
			}			
			
			// update existing record
			$this->db->where(array('time_sheet_id' => $time_sheet_id, 'entity_id' => $this->entity_id, 'user_id' => $this->ot_user->get('user_id'), 'entry_date' => $data['cur_date'],'invoice_id ' => '0', 'is_progress' => 0));
			$this->db->update('time_sheet', array('is_progress' => 1, 'last_updated_by' => $this->ot_user->get('user_id'), 'last_updated_date' => $this->auth->get_timezone_date('Y-m-d H:i:s', 'UTC')));
			
			// if rows affected retun timesheet id
			if ($this->db->affected_rows())
				return array('time_sheet_id' => $time_sheet_id);

		} else {
			// strip non required fields
			$this->load->library('table_fields');
			$data = $this->table_fields->strip_fields('timesheets', $data);
			if (!$data)
			{
				$this->response->error($this->table_fields->error, true);			
				return false;
			}
			$data['is_progress'] = 1;
			if ($result = $this->save($data))
			{
				
				return $result;	
			}
		}
		
		$this->response->error('UNABLE_START');
		return false;
	}
	
	public function stop_time_sheet ($data, $t_hours)
	{
		
		if (!isset($data['cur_date']) || strtotime($data['cur_date'])<strtotime($this->auth->get_timezone_date('Y-m-d', true)))
		{
			$date = $this->get_current_datetime();
			$data = array_merge($data,$date);
		}
		
		// update time sheet
		$where = array('time_sheet_id' => $data['time_sheet_id'], 'entity_id' => $this->entity_id, 'user_id' => $this->ot_user->get('user_id'), 'invoice_id ' => '0', 'is_progress' => 1);
		if (!is_member()) {
			unset($where['user_id']);
		}
		$this->db->where($where);
		$this->db->update('time_sheet', array('is_progress' => 0, 'hours' =>$t_hours, 'last_updated_by' => $this->ot_user->get('user_id'), 'last_updated_date' => $this->auth->get_timezone_date('Y-m-d H:i:s', 'UTC')));
		
		return $data['time_sheet_id'];
	}
	
	public function delete ($id)
	{
		$this->db->from('time_sheet AS ts');
		$where = array('ts.entity_id' => $this->entity_id,'ts.time_sheet_id' => $id, 'ts.is_progress' => 0);
		$this->db->select('concat("-", ts.hours) AS hours, ts.project_id,ts.task_type_id, ts.project_task_id, ts.user_id', false);
		$this->db->where($where);
		if (!is_admin()) {
			$this->db->join('project_users AS pru','ts.project_id=pru.project_id AND pru.user_id ='.$this->ot_user->get('user_id'));
		}
		$query = $this->db->get();
		$row = $query->row_array();		

		if ($row) {
// 			$this->db->where($where);
			if ($this->db->delete('time_sheet', array('entity_id' => $this->entity_id,'time_sheet_id' => $id, 'is_progress' => 0)))
			{
				$tmp = $this->delete_details($id);
				$this->load->library('time_sheet_table');
				$this->time_sheet_table->update_actual_value($row);
				
				// update task worked hours
				$hours = $row['hours'];
				$this->db->where(array('entity_id' => $this->entity_id, 'task_id' =>$row['project_task_id']));
				$this->db->set('worked_hours', 'worked_hours+'.$hours, FALSE);
				$this->db->update('project_task');

				return true;
			}
		}		
		return false;
	}
	
	public function delete_details ($time_sheet_id, $ids = array(), $force = false)
	{
		// delete time sheet details
		if ($ids)
		{
			$this->db->where_in('time_sheet_detail_id', $ids);
		}

		$where = array('entity_id' => $this->entity_id, 'time_sheet_id' => $time_sheet_id);
		if (!$force) $where['is_progress'] = 0;

		$this->db->where($where);
		$this->db->delete('time_sheet_detail');
		
		return ($ids)?$ids:true;
	}
	
	public function get_team_hours($data)
	{
		$from_date	= (!empty($data['from_date'])) ? $data['from_date'] : null;
		$to_date	= (!empty($data['to_date'])) ? $data['to_date'] : null;

		// if (empty($data['filter_project_id'])) {
			// get projects map
			$this->load->model('projects');
			$where  	= array('filters'=>array('pr.is_active' => 1));
			if (!empty($data['filter_project_id'])) {
				$where['filters']['pr.project_id'] = explode(',',$data['filter_project_id']);
			}
			$projects	= $this->projects->get_projects('pr.project_id, pr.project_name', $where);

			if ($projects) {
				foreach ($projects as $row) {
					$filter_projects[] = $row['project_id'];
				}
				$data['filter_project_id'] = implode(',',$filter_projects);
			} else if (!empty($data['filter_project_id'])) {
				return array();
			}
		// }
		
		if ($from_date && $to_date)
		{
			return $this->get_team_hours_days($data);
		}
		else
		{
			unset($data['from_date']);
			unset($data['to_date']);
			return $this->get_team_hours_day($data);
		}
	}


	public function get_total_hours($options = array())
	{
		$this->load->model('projects');
		$projects	= $this->projects->get_projects('pr.project_id, pr.project_name', array('filters'=>array('pr.is_active' => 1)));

		if ($projects) {
			foreach ($projects as $row) {
				$filter_projects[] = $row['project_id'];
			}
		}


		$this->db->select('sum(hours) AS day_total, is_billable');
		$this->db->select("DATE_FORMAT(entry_date, '%Y-%m-%d') as entry_date", false);
		$this->db->select("invoice_id");
		$this->db->from('time_sheet');
		
		$where	= array(
			'entity_id'	=> $this->ot_app->get('entity_id'),
			'user_id'	=> !empty($options['user_id']) ? $options['user_id'] : $this->ot_user->get('user_id')
		);

		if (!empty($options['filters']))
		{
			$where	= array_merge($where, $options['filters']);
		}
		$this->db->where($where);

		if (!empty($options['where_str']))
		{
			$this->db->where($options['where_str'], NULL, FALSE);
		}
	
		$this->db->where_in('project_id',$filter_projects);

		$group_by = !empty($options['group_by'])?$options['group_by']:'entry_date';	
		$this->db->group_by($group_by);

		$query = $this->db->get();

		return $query->result_array();
	}

	private function get_team_hours_day($data)
	{
		$result = array();
		
		$date = (!empty($data['date']))?$data['date']:$this->auth->get_timezone_date('Y-m-d', true);
		
		$filter_users = array();
		$filter_projects	= array();

		if(!empty($data['filter_user_id']))
		{
			$filter_users = explode(',', $data['filter_user_id']);
		}

		if(!empty($data['filter_project_id']))
		{
			$filter_projects = explode(',', $data['filter_project_id']);
		}

		/*if(!empty($data['filter_project_id']))
		{
			$filter_projects = explode(',', $data['filter_project_id']);
			$this->db->select('eu.user_id, eu.first_name, eu.last_name, eu.user_image, eu.time_zone_code, eu.is_active', false);
		} else {		*/
			$users	= $this->get_team_users('DISTINCT eu.user_id, eu.first_name, eu.last_name, eu.user_image, eu.time_zone_code, eu.is_active', $filter_users, $filter_projects, false);
		
			if (!$users)
				return $result;
			$result['users']	= array_key_index($users, 'user_id');
		// }
		
		// get users hours details
		$this->db->select('t.user_id, concat(pr.project_code, pr.project_name) as project_name, tt.name AS task_type, t.time_sheet_id, t.activity_name, t.is_billable, t.hours, t.notes,t.is_progress, td.from_time, t.estimated_hours,t.project_task_id, pt.task_number,pt.task_status_id', false);
		$this->db->from('time_sheet AS t');
		$this->db->join('time_sheet_detail AS td', 't.entity_id=td.entity_id and td.time_sheet_id = t.time_sheet_id AND td.is_progress = 1', 'left');
		$this->db->join('entity_users AS eu', 'eu.user_id=t.user_id');
		$this->db->join('project AS pr', 't.entity_id=pr.entity_id and t.project_id = pr.project_id');
		$this->db->join('task_type AS tt', 't.entity_id=tt.entity_id and t.task_type_id = tt.task_type_id');
		$this->db->join('project_task AS pt', 't.entity_id=pt.entity_id and t.project_task_id=pt.task_id', 'left');
		$this->db->where_in('t.user_id', array_keys($result['users']));
		$this->db->where(array('t.entry_date' => $date, 't.entity_id' => $this->entity_id));

		if (!empty($filter_projects))
		{
			$this->db->where_in('pr.project_id', $filter_projects);
			if ($filter_users) {
				$this->db->where_in('t.user_id',$filter_users);
			}
			$this->db->order_by('eu.first_name');
		} else {
			$this->db->order_by('t.user_id, t.time_sheet_id');
		}

		$query = $this->db->get();

		$details	= $query->result_array();
		foreach ($details as $key=>$val)
		{
			/*if (!empty($data['filter_project_id']))
			{
				$result['users'][$val['user_id']] = array('user_id' => $val['user_id'], 'first_name' => $val['first_name'], 'last_name' => $val['last_name'], 'user_image' => $val['user_image'], 'time_zone_code' => $val['time_zone_code'], 'is_active' => $val['is_active']);
				unset($val['first_name']);
				unset($val['last_name']);
				unset($val['user_image']);
				unset($val['time_zone_code']);
				unset($val['is_active']);
			}*/
			$details[$key]['from_time']	= empty($val['from_time']) ? "" : time_in_12_hour_format($val['from_time'], true);
			$details[$key]['cur_time']	= time_in_12_hour_format($this->auth->get_timezone_date('', $result['users'][$val['user_id']]['time_zone_code']), true);
		}

		$result['details']	= $details;
		$result['users']	= isset($result['users'])?$result['users']:array();
		/*$this->db->select('t.user_id, concat(pr.project_code, pr.project_name) as project_name, t.hours', false);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr', 't.entity_id=pr.entity_id and t.project_id = pr.project_id');
		$this->db->where(array('t.entry_date' => $date, 't.entity_id' => $this->ot_app->get('entity_id')));
		$this->db->where_in('t.user_id', array_keys($result['users']));
		if (!empty($data['filter_project_id']))
		{
			$this->db->where_not_in('pr.project_id', $filter_projects);
		}
		$query = $this->db->get();
		$details	= $query->result_array();

		$result['others'] = $details;*/
		
		return $result;
	}

	private function get_team_hours_days($data)
	{
		$result				= array();
		$filter_users		= array();
		$filter_projects	= array();
		
		$date	= (!empty($data['date'])) ? $data['date'] : $this->auth->get_timezone_date('Y-m-d', true);

		if(!empty($data['filter_user_id']))
		{
			$filter_users	= explode(',', $data['filter_user_id']);
		}

		if(!empty($data['filter_project_id']))
		{
			$filter_projects = explode(',', $data['filter_project_id']);
		}
			// $this->db->select('eu.user_id, eu.first_name, eu.last_name, eu.user_image, eu.time_zone_code, eu.is_active', false);
		// } else {		
			$users	= $this->get_team_users('DISTINCT eu.user_id, eu.first_name, eu.last_name, eu.user_image, eu.time_zone_code, eu.is_active', $filter_users, $filter_projects, false);
		
			if (!$users)
				return $result;
			$result['users']	= array_key_index($users, 'user_id');
		// }

		// get users hours details
		$this->db->select('sum(t.hours) as hours, t.user_id, t.entry_date', false);
		$this->db->from('time_sheet AS t');
		$this->db->join('entity_users AS eu', 'eu.user_id=t.user_id');
		$this->db->where(array(
			't.entry_date <='	=> $data['to_date'],
			't.entry_date >='	=> $data['from_date'],
			't.entity_id'		=> $this->ot_app->get('entity_id')
		));

		$this->db->where_in('t.user_id', array_keys($result['users']));

		if (!empty($filter_projects))
		{
			$this->db->where_in('t.project_id', $filter_projects);
			if ($filter_users) {
				$this->db->where_in('t.user_id',$filter_users);
			}
		}

		$this->db->group_by('t.user_id, t.entry_date');
		
		$query = $this->db->get();

		$details	= $query->result_array();

		foreach ($details as $key=>$val)
		{
			/*if (!empty($data['filter_project_id']))
			{
				$result['users'][$val['user_id']] = array('user_id' => $val['user_id'], 'first_name' => $val['first_name'], 'last_name' => $val['last_name'], 'user_image' => $val['user_image'], 'time_zone_code' => $val['time_zone_code'], 'is_active' => $val['is_active']);
				unset($val['first_name']);
				unset($val['last_name']);
				unset($val['user_image']);
				unset($val['time_zone_code']);
				unset($val['is_active']);
			}*/
			$details[$key]['cur_time']	= time_in_12_hour_format($this->auth->get_timezone_date('', $result['users'][$val['user_id']]['time_zone_code']), true);
		}

		$result['users']	= array_values($result['users']);
		$result['details']	= $details;

		return $result;
	}

	function get_team_users($select = '', $filter_users = array(), $filter_projects=array(), $isActive=true)
	{
		$users = array();
		// get mapped project ids
		$this->db->select('DISTINCT pr.project_id', false);
		$this->db->from('project as pr');
		$this->db->join('project_users AS pmu','pr.entity_id = pmu.entity_id and pr.project_id=pmu.project_id');
		$this->db->where(array('pr.entity_id' => $this->entity_id, 'pr.is_active' => 1 ,'pmu.user_id' => $this->ot_user->get('user_id'), 'pmu.user_role !=' => 'M'));

		$query = $this->db->get();
		$projects = $query->result_array();

// 		$this->db->where_in('pu.project_id', $filter_projects);

		if ($projects)
		{
			$project_ids = array();
			if (empty($filter_projects))
			{
				foreach ($projects as $val)
				{
					$project_ids[] = $val['project_id'];
				}
			}
			else
			{
				foreach ($projects as $val)
				{
					if (in_array($val['project_id'], $filter_projects))
					{
						$project_ids[] = $val['project_id'];
					}
				}
			}

			$select = !empty($select)?$select:'DISTINCT eu.user_id, eu.first_name, eu.last_name, eu.user_image';
			// get related users
			$this->db->select($select, false);
			$this->db->from('entity_users AS eu');
			$this->db->join('project_users AS pmu', 'pmu.entity_id = eu.entity_id and pmu.user_id=eu.user_id');
			$this->db->where(array('eu.entity_id' => $this->entity_id, 'eu.user_role !=' => 'A'));
			if ($isActive)
			{
				$this->db->where('eu.is_active', 1);
			}
			if(!empty($filter_users))
				$this->db->where_in('eu.user_id', $filter_users);
			if(!empty($project_ids))
				$this->db->where_in('pmu.project_id', $project_ids);
			$this->db->order_by('eu.first_name');
			$query = $this->db->get();
			$users = $query->result_array();
		}
		
		return $users;
	}
	
	public function get_timesheet_approve_list($select = '', $options = array())
	{
		$select = ($select)?$select:'u.user_id, u.first_name, u.last_name, u.user_image, min(entry_date) as from_date, max(entry_date) as to_date, count(DISTINCT entry_date) AS days, sum(hours) as hours';
		$query = $this->approve_list_query($select, $options);

		$result = $query->result_array();
		
		return $result;
	}

	public function get_timesheet_approved_list($select = '', $options = array())
	{
		$select	= !empty($select) ? $select : 'u.user_id, u.first_name, u.last_name, u.user_image, min(entry_date) as from_date, max(entry_date) as to_date, count(DISTINCT entry_date) AS days';
		$query	= $this->approve_list_query($select, $options, 'A');

		$result = $query->result_array();
		return $result;
	}

	
	public function approve_list_query($select, $options = array())
	{
		$this->db->select($select);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr','t.entity_id = pr.entity_id and t.project_id=pr.project_id','INNER');
		$this->db->join('entity_users AS u','t.entity_id = u.entity_id and t.user_id=u.user_id','INNER');
		$this->db->join('project_users AS pru','pr.entity_id=pru.entity_id and pr.project_id=pru.project_id','INNER');
		
		$this->db->where(array('t.entity_id'=>$this->entity_id, 'pru.user_id'=>$this->ot_user->get('user_id'), 't.approval_status'=>'S', 'pru.user_role !=' => "M"));
		
		if (!empty($options['filters'])) {
			foreach($options['filters'] as $key=>$value)
				if (is_array($value))
					$this->db->where_in($key,$value);
				else
					$this->db->where($key,$value);
		}	
			
		$this->db->group_by('t.user_id');
		$this->db->order_by('from_date, to_date');
		
		return $this->db->get();

	}	
	
	public function get_time_content_details($user_id, $options=array())
	{
		$this->db->select('pr.project_id, pr.project_code, pr.project_name, ty.name as task_type_name, t.activity_name as project_task_name,sum(t.hours) AS hours, ty.task_type_id, pt.task_id, t.approval_status');
		$this->db->select("DATE_FORMAT(t.entry_date, '%Y-%m-%d') as entry_date", false);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr','t.entity_id=pr.entity_id and t.project_id=pr.project_id','INNER');
		$this->db->join('project_users AS pru','pr.entity_id=pru.entity_id and pr.project_id=pru.project_id','INNER');		
		$this->db->join('task_type AS ty','t.entity_id=ty.entity_id and t.task_type_id=ty.task_type_id','INNER');
		$this->db->join('project_task AS pt','t.entity_id=pt.entity_id and t.project_task_id=pt.task_id','LEFT');
		$this->db->where(array('t.entity_id'=>$this->entity_id, 'pru.user_id'=>$this->ot_user->get('user_id'), 'pru.user_role !=' => "M", 't.user_id'=>$user_id, 't.approval_status !='=>''));

		if (!empty($options['filters'])) {
			foreach($options['filters'] as $key=>$value) {
				if (is_array($value))
					$this->db->where_in($key,$value);
				else
					$this->db->where($key,$value);
			}
		}	
			
		$this->db->group_by('entry_date, pr.project_id, t.task_type_id, t.activity_name');
		
		$query = $this->db->get();
		$result = $query->result_array();
//echo $this->db->last_query();
		return $result;
	}

	// 	return timesheet query
	public function list_query($select, $options = array(), $all = false, $raw_query=false)
	{
		$select .=',if(t.hours,1,0) AS p_hours';
		$this->db->select($select, false);
		$this->db->from('time_sheet AS t');
		$this->db->join('project AS pr',  't.entity_id = pr.entity_id and t.project_id = pr.project_id', 'INNER');
		$this->db->join('project_task AS pt', 't.entity_id = pt.entity_id and t.project_id=pt.project_id and t.project_task_id = pt.task_id', 'LEFT');
		$this->db->join('task_type AS ty', 't.entity_id = ty.entity_id and t.task_type_id=ty.task_type_id', 'LEFT');
		$this->db->join('project_users AS pu', 'pr.entity_id = pu.entity_id and pr.project_id = pu.project_id AND t.user_id=pu.user_id', 'LEFT');

		$where	= array('t.entity_id' => $this->entity_id);

		if (!$all)
		{
			$where['t.user_id'] = !empty($options['user_id'])?$options['user_id']:$this->ot_user->get('user_id');
		}

		if (!empty($options['filters']))
		{
			$where = array_merge($where, $options['filters']);
		}
		$this->db->where($where);

		if ( !empty($options['project_ids']) )
		{
			$this->db->where_in('pr.project_id', $options['project_ids']);
		}
		
		if (!empty($options['where_str']))
		{
			$this->db->where($options['where_str'], NULL, FALSE);
		}
		
		if (!empty($options['group_by']))
		{
			$this->db->group_by($options['group_by']);
		}

		if (!$raw_query) {

			$order_by ='p_hours desc, ';
			$order_by .= !empty($options['order_by'])?$options['order_by']:'t.time_sheet_id';
			$order_by_direction = !empty($options['order_by_direction'])?$options['order_by_direction']:'desc';
			if ($order_by && $order_by_direction)
				$this->db->order_by($order_by,$order_by_direction);

			$from = !empty($options['from'])?$options['from']:0;
			if (!empty($options['count']))
			{
				$this->db->limit($options['count'], $from);
			}
		}
		return $this->db->get();
	}

	public function revoke_details($post_data)
	{
		if(empty($post_data))
		{
			return false;
		}

		$user_id	= $post_data['user_id'];

		$this->load->library('Auth');
		$cur_time = $this->auth->get_timezone_date();

		$data['approval_status'] 	= '';
		$data['approved_by']	 	= $this->ot_user->get('user_id');
		$data['last_updated_by'] 	= $this->ot_user->get('user_id');
		$data['last_updated_date'] 	= $cur_time;

		$where = array(
			'entity_id'			=> $this->entity_id,
			'user_id'			=> $user_id,
			'is_progress'		=> 0,
			'invoice_id'		=> 0,
			'approval_status'	=> 'A'
		);

		if(!empty($post_data['to_date']))
		{
			$where['entry_date <=']	= $post_data['to_date'];
			if(!empty($post_data['from_date']))
				$where['entry_date >=']	= $post_data['from_date'];
		}
		else if(!empty($post_data['from_date']))
		{
			$where['entry_date']	= $post_data['from_date'];
		}

		if(isset($post_data['billable']))
			$where['is_billable']	= $post_data['billable'];

		$this->db->where($where);

		if (!empty($post_data['project_id']))
			$this->db->where_in('project_id', implode(',', $post_data['project_id']));
		
		if (!empty($post_data['task_type_id']))
			$this->db->where_in('task_type_id', implode(',', $post_data['task_type_id']));

		$this->db->update('time_sheet', $data);
		return true;
	}

	public function approve_details($post_data, $is_all=false)
	{
		if(empty($post_data) && !$is_all)
		{
			return false;
		}

		$this->load->library('Auth');
		$cur_time = $this->auth->get_timezone_date();

		$data['approval_status'] 	= 'A';
		$data['approved_by']	 	= (!$is_all)?$this->ot_user->get('user_id'):0;
		$data['last_updated_by'] 	= $this->ot_user->get('user_id');
		$data['last_updated_date'] 	= $cur_time;

		$where	= array('entity_id'=>$this->entity_id);

		if (!empty($post_data['user_id']) && !$is_all)
		{
			$user_id	= $post_data['user_id'];
			$where['user_id']	= $user_id;
			$where['approval_status']	= 'S';
		}

		$where['is_progress']	= '0';
		$where['invoice_id']	= '0';

		if(!empty($post_data['to_date']))
		{
			$where['entry_date <='] = $post_data['to_date'];
			if(!empty($post_data['from_date']))
				$where['entry_date >='] = $post_data['from_date'];
		}
		else if(!empty($post_data['from_date']))
		{
			$where['entry_date'] = $post_data['from_date'];
		}

		if(isset($post_data['billable']))
			$where['is_billable'] = $post_data['billable'];

		$this->db->where($where);

		if (!empty($post_data['project_id'])) 
			$this->db->where_in('project_id', implode(',',$post_data['project_id']));

		if (!empty($post_data['task_type_id'])) 
			$this->db->where_in('task_type_id', implode(',',$post_data['task_type_id']));		

		 $this->db->update('time_sheet', $data);

		 return true;
	}

	public function reject_timesheet($post_data)
	{
		if(empty($post_data))
		{
			return false;
		}

		$user_id	= $post_data['user_id'];

		$this->load->library('Auth');
		$cur_time = $this->auth->get_timezone_date();

		$data['approval_status'] 	= '';
		$data['last_updated_by'] 	= $this->ot_user->get('user_id');
		$data['last_updated_date'] 	= $cur_time;

		$where	= array(
			'entity_id'	=> $this->entity_id,
			'user_id'	=> $user_id,
			'is_progress'	=> 0,
			'invoice_id'	=> 0,
			'approval_status'	=> 'S'
		);

		if(!empty($post_data['to_date']))
		{
			$where['entry_date <='] = $post_data['to_date'];
			if(!empty($post_data['from_date']))
				$where['entry_date >='] = $post_data['from_date'];
		}
		else if(!empty($post_data['from_date']))
		{
			$where['entry_date'] = $post_data['from_date'];
		}

		$this->db->where($where);
		
		if (!empty($post_data['project_id'])) 
			$this->db->where_in('project_id', implode(',',$post_data['project_id']));

		if (!empty($post_data['task_type_id'])) 
			$this->db->where_in('task_type_id', implode(',',$post_data['task_type_id']));

		$this->db->update('time_sheet', $data);

		return $this->db->affected_rows();
	}

	public function get_timesheet_approvable_users()
	{
		$this->db->select('pu.user_id, eu.first_name, eu.last_name');
		$this->db->from('project_users as pu');
		$this->db->join('entity_users as eu', 'pu.user_id=eu.user_id');
		$this->db->group_by('eu.user_id');
		$this->db->where(array(
			'eu.entity_id'	=> $this->entity_id,
			'pu.user_role !='	=> 'M'
		));
		$query	= $this->db->get();
		return $query->result_array();
	}
}
/* End of file */
