<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
	$fields	= array(
		'form_open'	=> array(
			'id'			=> 'client_form',
			'name'			=> 'client_form',
			'class'			=> 'form-horizontal'
		),
		'client_name'	=> array(
			'name'			=> 'client_name',
			'id'			=> 'client_name',
			'class'			=> 'form-control',
			'data-bind'		=> 'value:client_name',
			'placeholder'	=> lang('CLIENT_NAME'),
		),
		'client_code'	=> array(
			'name'			=> 'client_code',
			'id'			=> 'client_code',
			'class'			=> 'form-control',
			'data-bind'		=> 'value:client_code',
			'maxlength'		=> '6',
			'placeholder'	=> lang('CLIENT_CODE'),
		),
		'Name'	=> array(
			'name'			=> 'Name',
			'id'			=> 'Name',
			'class'			=> 'form-control form-group input-sm',
			'data-bind'		=> 'value:name, event:{blur:$parent.add_new_contact($index())}',
			'placeholder'	=> lang('CONTACT_NAME'),
		),
		'Title'	=> array(
			'name'			=> 'Title',
			'id'			=> 'Title',
			'class'			=> 'form-control input-sm',
			'data-bind'		=> 'value:title',
			'placeholder'	=> lang('CONTACT_TITLE'),
		),
		'email'	=> array(
			'type'			=> 'email',
			'name'			=> 'email',
			'id'			=> 'email',
			'class'			=> 'form-control input-sm',
			'data-bind'		=> 'value:email',
			'placeholder'	=> lang('EMAIL'),
		),
		'workphone'	=> array(
			'name'			=> 'workphone',
			'id'			=> 'workphone',
			'class'			=> 'form-control input-sm phone',
			'data-bind'		=> 'numberOnly:true, value:workphone',
			'maxlength'		=> '12',
			'placeholder'	=> lang('OFFICE_PHONE'),
		),
		'mobile'	=> array(
			'name'			=> 'mobile',
			'id'			=> 'mobile',
			'class'			=> 'form-control input-sm mobile',
			'data-bind'		=> 'numberOnly:true, value:mobile',
			'maxlength'		=> '12',
			'placeholder'	=> lang('MOBILE_PHONE'),
		),
	);
	//$hidden	= array('client_id');
?>
<?php switch ($name) { ?>
<?php case "edit": ?>
<div class="panel sidebar-fixed-header panel-primary" data-bind="with:popupitem">
	<div class="panel-heading">
		<h3 class="panel-title dib" style="margin:5px 0px;">
			<!-- ko ifnot:client_id -->
			<?php echo lang('ADD_NEW_CLIENT'); ?>
			<!-- /ko -->
			<!-- ko if:client_id -->
			<?php echo lang('EDIT_CLIENT'); ?>
			<!-- /ko -->
		</h3>
		<div class="btn-group pull-right">
			 <button class="btn btn-sm btn_save btn-success" data-bind="click:save">
				<i class="icon icon-save icon-white"></i>&nbsp;&nbsp;<?php echo lang('SAVE'); ?>
		     </button>
			<button class="btn btn-primary btn-sm" data-bind="click:cancel">
				<span class="icon-remove-sign icon-white"></span>
			</button>
		</div>
	</div>
	<div class="panel-body">
		<div class="row">
			<div class="col-lg-10 form-group">
				<?php echo form_input($fields['client_name']); ?>
			</div>
		</div>
		<div class="row">
			<div class="col-lg-6 ">
				<div class="form-group input-group">
					<span class="input-group-addon">
						<i>Code</i>
					</span>
					<?php echo form_input($fields['client_code']); ?>
				</div>
			</div>
			<div class="col-lg-6 ">
				<span class="colorpicker background-picker" data-bind="colorpicker:{value:bg_color, colors:Otime.bgpicker_colors}"></span>
			</div>	
		</div>
		<div class="row">
			<div class="col-lg-10 form-group">
				<textarea rows="5" cols="" max-length="500" class="form-control" data-bind="value:address" placeholder="Address" id="address"></textarea>
			</div>
		</div>
		<div>
				<span class="btn btn-success btn-sm"><?php echo lang('CONTACTS'); ?></span>
		</div>
		<div class="timeline">
			
			<!-- ko foreach:contacts -->
			<div class="row block contact-list">
				<span class="icon-user icon-metro img-circle bg-blue nb"></span>
				<div class="well npb nm">
					<div class="delete-btn">
						<a href="javascript:;" data-bind="click:$parent.removeContact" class="close" style="" id="delete">
							<i class="icon-trash"></i>
						</a>
					</div>
					<div class="row">
						<div class="col-lg-6">
							<?php echo form_input($fields['Name']); ?>
							<div class="row">
								<div class="col-lg-12">
									<div class="form-group input-group">
										<i class="input-group-addon input-sm">
											<?php echo lang('ROLE'); ?>
										</i>
										<?php echo form_input($fields['Title']); ?>
									</div>
								</div>
							</div>
						</div>
						<div class="col-lg-6">
							<div class="row">
								<div class="col-lg-12">
									<div class="form-group input-group">
										<span class="input-group-addon input-sm">
											<i class="icon-envelope"></i>
										</span>
										<?php echo form_input($fields['email']); ?>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-lg-12">
									<div class="form-group input-group">
										<span class="input-group-addon input-sm">
											<i class="icon-phone"></i>
										</span>
										<?php echo form_input($fields['workphone']); ?>
									</div>
								</div>
							</div>
							<div class="row">
								<div class="col-lg-12">
									<div class="form-group input-group">
										<span class="input-group-addon input-sm">
											<i class="icon-mobile-phone"></i>
										</span>
										<?php echo form_input($fields['mobile']); ?>
									</div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!-- /ko -->
		</div>
		<div class="clearfix"></div>
		<div class="sep">&nbsp;</div>
	</div>
</div>
<?php ;break;?>
<?php }?>
