<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	set_cache_header();
?>
<div id="expense-container" class="dib fh fw">
	<?php if (!$from_module): ?>
	<div class="page-header-bar">
		<span class=" title"><?php echo lang('EXPENSE_ENTRY'); ?></span>
		<div id="alert_message" class="ac col-md-9 fix-it"></div>
	</div>
	<div id="body-container">
		<div id="list-container">
			<div class="container">
				<div class="pull-left input-group" style="margin-left:30px;">
					<div style="position:relative;" class="pull-left">
						<h4 style="padding:4px 6px;" class="pull-left nm" data-bind="date:{date:date, format:'MMM, YYYY'}"></h4>
						<input type="text" data-bind="value:date, datepicker:{minViewMode:'months'}" class="input-sm dtpicker npl npr cp" />
					</div>
					<div class="pull-left">
						<button type="button" class="btn no-bg nb icon-chevron-up split up np" data-bind="click:dtup"></button>
						<button type="button" class="btn no-bg nb icon-chevron-down split np" data-bind="click:dtdown"></button>
					</div>
				</div>
				<a data-bind="visible:appr_listing().length, text:'Pending approval ('+ appr_listing().length + ')'" class="label label-primary title cp" style="margin-left:20px;" href="#approve_expenses"></a>
				<div class="col-md-8 pull-right row npr filter">
					<div class="col-md-4" data-bind="visible:Object.values(f_projects()).length>0">
						<select class="select filters form-control" data-bind="options:Object.values(f_projects()), optionsText:'project_name', optionsValue:'project_id', selectedOptions:sel_project, chosen:true" multiple="multiple" style="margin-right:82px;"></select>
					</div>
					<?php if(!is_member($role)): ?>
					<div class="col-md-4" data-bind="visible:clients().length>0">
						<select class="form-control select filters " data-bind="options:clients, optionsText:'client_name', optionsValue:'client_id', selectedOptions:sel_client, chosen:true" multiple="multiple" style="margin-right:10px;"></select>
					</div>
					<div class="col-md-4" data-bind="visible:users().length>0">
						<select class="form-control select filters " data-bind="options:users, optionsText:'user_name', optionsValue:'user_id', selectedOptions:sel_user, chosen:true" multiple="multiple" style="margin-right:10px;"></select>
					</div>
					<?php endif; ?>
				</div>
			</div>
			<div class="timeline nbl new-item">
				<div class="row block expense-list npb edit new" data-bind="visible:is_show_new">
					<span class="icon-plus bg-green icon-metro img-circle nb hidden-xs"></span>
					<div class="well">
						<div class="row" data-bind="template:{name:'expenses-edit', data:newItem}"></div>
					</div>
				</div>
				<div class="row block expense-list npb">
					<div class="block row np nm">
						<div class="well list_head nm">
							<div class="row">
								<div class="col-md-1 col-xs-2 col-sm-2"><b><?php echo lang('DATE'); ?></b></div>
								<div class="col-md-4 col-xs-4 col-sm-3"><b><?php echo lang('PROJECT'); ?></b></div>
								<div class="col-md-3 col-xs-3 col-sm-4 cutter-left"><b><?php echo lang('DETAILS'); ?></b></div>
								<div class="col-md-2 col-sm-2 col-xs-2 ar"><b><?php echo lang('AMOUNT'); ?></b></div>
								<div class="col-md-1 col-sm-1 col-xs-1"></div>
							</div>
						</div>
					</div>
				</div>
				<!-- ko foreach:listing -->
				<div class="row block expense-list npb">
					<div class="block row nm" data-bind="hidden:_info.is_edit_mode">
						<div class="col-md-1 col-xs-2 col-sm-2">
							<div class="pull-left label label-default">
								<h4 class="no-margin" data-bind="date:{date:expense_date, format:'DD'}"></h4>
								<span data-bind="date:{date:expense_date, format:'MMM'}"></span>
							</div>
						</div>
						<div class="col-md-4 col-xs-4 col-sm-3">
							<div class="pull-left" style="padding-top:2px">
								<img data-bind="img:user_image, attr:{title:user_name}" class="img32x32" />
							</div>
							<div class="col-md-10 col-xs-4 col-sm-3">
								<!-- ko text:user_name --><!-- /ko -->
								<br>
								<div data-bind="text:_info.project_value"></div>
							</div>
						</div>
						<div class="expenseNotes col-md-3 col-xs-3 col-sm-4">
							<div class="nml">
								<!-- ko if:attach_details().file_name -->
								<div data-bind="with:attach_details" class="pull-left" style="padding-right:5px;">
									<a data-bind="attr:{href:download_url}" id="added_file">
										<span class="icon icon-paper-clip"></span>
									</a>
								</div>
								<!-- /ko -->
								<span data-bind="attr:{'class': (attachment_id() > 0)?'': 'cutter-left'}"><!-- ko text:name --><!-- /ko --></span>
								<!-- ko if:expense_type_id()>0 && quantity()>0 -->
								<span class="gray"  data-bind="text:' ('+ quantity() + ' ' + _info.units()+')'">
								</span>
								<!-- /ko -->
							</div>
							<div class="col-md-12 nml npl">
								<!-- ko if:notes()!='' -->
								<small data-bind="text:notes" class="pull-left" style="padding-left:15px"></small>
								<!-- /ko -->
							</div>
						</div>
						<div class="col-md-2 col-sm-2 col-xs-2 ar amount h4 npr">
							<span data-bind="currency:{val:amount, symbol:'<?php echo CURRENCY;?>'}"></span>
						</div>
						<div class="col-md-1 col-sm-1 col-xs-1 text-center">
							<!-- ko if:<?php if(!is_admin($role)): ?>edit_permission()==true && <?php endif; ?>Otime.app.is_edit_mode()==false&&(invoice_id==0||!invoice_id)-->
								<div class="edit">
									<span data-bind="click:$parent.remove" class="pull-right"><i class="icon icon-trash cp"></i></span>
									<span class="separator pull-right">&nbsp;|&nbsp;</span>
									<span data-bind="click:$parent.edit" class="pull-right edit_time"><i class="icon icon-pencil"></i></span>
								</div>
							<!-- /ko -->
							<!-- ko if:(invoice_id&&invoice_id!=0) -->
								<i class="icon icon-lock pull-right gray"></i>
							<!-- /ko -->
						</div>
					</div>
					<div class="well list_head" data-bind="visible:_info.is_edit_mode">
						<div class="row">
							<div class="col-md-12 np" data-bind="template:{name:'expenses-edit'}">
							</div>
						</div>
					</div>
					<hr class="nm" />
				</div>
				<!-- /ko -->
			</div>
			<div class="text-center" data-bind="visible:listing().length<1" style="margin-top: 50px;">
				<span class="well"><?php echo lang('NO_EXPENSES'); ?></span>
			</div>
			<div class="label-default" style="margin-left:50px;margin-top:10px;" data-bind="visible:listing().length>1">
				<div class="block row npb">
					<div class="col-md-1">&nbsp;</div>
					<div class="ar col-md-8">
					<!--<h5 class="pull-right label"><?php echo lang('TOTAL'); ?></h5>
						-->
					<h3 class="col-md-2 nmt pull-right">
						<strong class="label np"><?php echo lang('TOTAL'); ?></strong>
					</h3>
					</div>
					<div class="ar col-md-1 total_expenses" >
						<h3 class="nm">
							<span class="label npr" data-bind="currency:{val:total_amount, symbol:'<?php echo CURRENCY; ?>'}"></span>
						</h3>
					</div>
					<div class="col-md-2">&nbsp;</div>
				</div>
			</div>
		</div>
		<?php
			endif;
			if(!is_member($role)):
				$this->load->view('expenses/approve');
			endif;
		?>
	</div>
</div>
<script type="text/html" id="expenses-edit">
	<div class="col-md-12 np">
		<div class="media" style="overflow:visible;">
			<div class="media-left">
				<div class="form-control cp np pr" style="width:110px;">
					<span style="padding:6px 8px;" class="dib fw" data-bind="date:{date:expense_date}"></span>
					<input type="text" class="dtpicker" data-bind="value:expense_date, datepicker:true" style="height:34px;padding-left:3px;padding-right:3px;">
				</div>
			</div>
			<div class="media-body" style="overflow:visible;">
				<div class="container np nm">
					<div class="col-md-4 col-sm-6 npl form-group">
						<select class="form-control" data-bind="options:Object.values($parent.projects()), optionsText:'project_name', optionsValue:'project_id', value:project_id, chosen:true"></select>
					</div>
					<div class="col-md-4 col-sm-6 npl form-group">
						<select class="form-control" data-bind="options:Object.values($parent.categories()), optionsText:'name', optionsValue:'expense_type_id', optionsPrice:'unit_price', value:expense_type_id, chosen:true"></select>
					</div>
					<div class="col-md-2 col-xs-6 npl form-group quantity" data-bind="visible:expense_type_id()<=0 || unit_price() > 0">
						<div class="input-group">
							<input type="text" class="form-control" data-bind="value:quantity, numberOnly:true, enable:expense_type_id()>0&&unit_price()>0, attr:{'placeholder':_info.units()}, valueUpdate:'afterkeydown'" />
							<!-- ko if:_info.units -->
						  	<span class="input-group-addon" data-bind="text:_info.units"></span>
							<!-- /ko -->
						</div>
					</div>
					<div class="col-md-2 col-xs-6 npl form-group amount">
						<div class="input-group">
							<input type="text" class="form-control amt" data-bind="value:amount, numberOnly:true, enable:expense_type_id()>0&&unit_price()<=0" placeholder="<?php echo lang('AMOUNT'); ?>"/>
							<!-- ko if:_info.units -->
							<span class="input-group-addon"><?php echo CURRENCY;?></span>
							<label style="font-size:12px;display:table-row;" class="gray ac"><?php echo CURRENCY;?> <!-- ko text:unit_price --><!-- /ko --> per <!-- ko text:_info.units --><!-- /ko --></label>
							<!-- /ko -->
						</div>
					</div>
				</div>
				<div id="notes_attach" class="form-group container np nm" data-bind="visible:project_id">
					<div class="col-md-8 form-group npl nm">
						<div class="col-md-6 np">
							<textarea rows="1" placeholder="Notes" class="col-md-12 col-sm-5 form-control textareaContent" data-bind="value:notes"></textarea>
						</div>
						<div class="col-md-6 form-group container nm cp">
							<div class="pull-right col-md-12 col-xs-8 npl al">
								<span class="npl" data-bind="click:uploadDialog, hidden:attachment_id()>0">
									<span class="icon icon-paper-clip"></span>&nbsp;<?php echo lang('ATTACH_RECEIPT'); ?>
								</span>
								<div class="file_info" data-bind="visible:attachment_id()>0">
									<div data-bind="with:attach_details" class="pull-left" style="padding-right:5px;">
										<a data-bind="attr:{href:download_url}" id="added_file">
											<span class="icon icon-paper-clip" style="color:#3A87AD"></span>
											<span class="text-info" data-bind="text:$parent.attach_details().file_name() + '.' + $parent.attach_details().file_type()"></span>
										</a>
									</div>
									<span class="delete" data-bind="click:fileremove"><i class="icon icon-remove"></i></span>
								</div>
								<input class="fileAttachment" type="file" id="attach_receipt" data-bind="value:attach_receipt, fileApi:_info.fileapi" name="attach_receipt" />
							</div>
						</div>
					</div>
					<div class="col-md-4 npl">
						<div class="btn-group">
							<button id="save" class="btn btn-sm btn-success" data-bind="click:$parent.save" name="save">
								<i class="icon-save icon-white">&nbsp;</i><?php echo lang('SAVE'); ?></button>
							<button id="cancel" class="btn btn-sm btn-primary" data-bind="click:$parent.cancel" name="cancel">
								<i class="icon-remove-sign icon-white">&nbsp;</i>
							</button>
						</div>
					</div>
				</div>
			</div>
		</div>
	</div>
</script>
<?php
	$jslang	= array();
	$tmp	= array('OTHER_EXPENSES', 'DAYS', 'CONFIRM_DELETE');
	foreach ($tmp as $val)
	{
		$jslang[$val]	= lang($val);
	}
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Expenses.language		= <?php echo json_encode($jslang); ?>;
	});
</script>
