﻿(function(Otime){

	Otime.Report	= new function Report(){
//		"use strict";

		var _this	= this;

		// Constants defines
		var DATE_FILTER_THIS_WEEK	= "TW",
			REPORT_COL_START_AND_END_TIME	= "TE",
			REPORT_CODE_TIME			= "T",
			REPORT_CODE_TIME_SUMMARY	= "TS",
			REPORT_CODE_TIME_DETAIL		= "TD",
			REPORT_CODE_TASK			= "A",
			REPORT_CODE_TASK_SUMMARY	= "AS",
			REPORT_CODE_TASK_DETAIL		= "AD",
			REPORT_CODE_TASK_MILESTONE	= "AM",
			REPORT_CODE_BUDGET			= "BU",
			REPORT_CODE_BUDGET_DETAIL	= "BD",
			REPORT_CODE_INVOICE				= "I",
			REPORT_CODE_INVOICE_SUMMARY		= "IS",
			REPORT_CODE_INVOICE_DETAIL		= "ID",
			REPORT_CODE_INVOICE_AGGING		= "IA",
			REPORT_CODE_INVOICE_OUTSTANDING	= "IO",
			REPORT_CODE_INVOICE_UNINVOICED	= "IU",
			REPORT_CODE_EXPENSES			= "E",
			REPORT_CODE_EXPENSES_SUMMARY	= "ES",
			REPORT_CODE_EXPENSES_DETAIL		= "ED",
			REPORT_CODE_ACTUAL		= "AC",
			REPORT_CODE_ESTIMATED_HOURS	= "EH",
			REPORT_CODE_ACTUAL_HOURS	= "AH",
			REPORT_CODE_AMOUNT			= "AM",
			REPORT_CODE_OUTSTANDING		= "OS",

			INVOICE_AMOUNT	= "IA",
			PAYMENT_AMOUNT	= "PA",
			
			GROUP_BY_CLIENT		= "CL",
			GROUP_BY_PROJECT	= "PR",
			GROUP_BY_TASK_TYPE	= "TT",
			GROUP_BY_USER		= "US",
			GROUP_BY_DATE		= "DA",
			GROUP_BY_PROJECT_TASK	= "PK",
			GROUP_BY_TOTAL_HOURS	= "TH",
			GROUP_BY_BILLABLE_HOUR	= "BH",
			GROUP_BY_BILLABLE_AMOUNT	= "BA",
			GROUP_BY_UNINVOICED_HOUR	= "UH",
			GROUP_BY_EXPENSES_CATEGORY	= "EC",
			GROUP_BY_EXPENSES_PERIOD	= "XP",
			GROUP_BY_INVOICE_STATUS		= "IT",
			GROUP_BY_INVOICE_PERIOD	= "IP",

			HOURS_UNAPPROVED	= "CU",
			EXPENSES_UNAPPROVED	= "EU",

			SORT_BY_DATE	= "DA",
			DATA_TYPE_NUMBER_COUNT	= "NC",
			DATA_TYPE_NUMBER	= "N",
			DATA_TYPE_CURRENCY	= "C",
			DATA_TYPE_STRING	= "S",
			DATA_TYPE_DATE		= "D",
			VIEW_SUMMARY	= "S",
			VIEW_UNINVOICED	= "U",
			VIEW_AGGING	= "A",
			VIEW_DETAIL		= "D";

		_this.lstFrom	= 0;

		_this.lstCount	= 15;

		_this.name		= "report";

		_this.model		= "ReportModel";

		_this.language	= null;

		_this.Status	= null;

		_this.filter_labels	= null;
		
		_this.Currency	= null;

		_this.report_code	= "";

		_this.appModel	= null;
		
		_this.prevent_refresh = false;

		_this.month_names_short = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
		
		_this.Filters	= function(data){
			var self	= this;

			data	= data || {};

			self.CL	= Otime.a(data.CL || ["all"]);
			self.PR	= Otime.a(data.PR || ["all"]);
			self.TT	= Otime.a(data.TT || ["all"]);
			self.US	= Otime.a(data.US || ["all"]);
			self.IT	= Otime.a(data.IT || ["all"]);
			self.EC	= Otime.a(data.EC || ["all"]);
			self.TKS= Otime.a(data.TKS || ["all"]);

			self.chosenCheckAll = function(koarr,$element,params) {
				var isAll	= false;
				if(koarr().length == 0)
				{
					isAll	= true;
				}  
				if(params.selected == "all")
				{
					//if(koarr().length > 1)
					if(koarr().length)
						isAll	= true;
				}
				if(isAll == true) 
					koarr(["all"]);
				else
					koarr.remove("all");
				
				var rep_code = _this.appModel._info.report_code();	

				var flt_order = [];
				switch (rep_code) {
					case REPORT_CODE_EXPENSES:
						flt_order = ['CL','PR','EC','US'];
					break;
					case REPORT_CODE_BUDGET:
						flt_order = ['CL','PR'];
					break;
					case REPORT_CODE_INVOICE:
						flt_order = ['CL','IT'];						
					break;
					case REPORT_CODE_TASK:
						flt_order = ['CL','PR','TT','US','TKS'];						
					break;
					default:
						flt_order = ['CL','PR','TT','US'];
						break;
				}
				
				var hrs_tmp = [];
				hrs_tmp[rep_code] = hrs_tmp[rep_code] || [];
				var ele_id = $element.attr("id");
				$.each(flt_order, function(k,val) {
					var sel_id='sel'+val;
					if (sel_id!= ele_id) {
						ele_id = sel_id;
					}

					if ($("#"+ele_id+" option:selected" ).val()!='all') {
						var key = $( "#"+ele_id+" option:selected" ).map(function () {return $(this).text();}).get().join();
						hrs_tmp[rep_code].push({label:key});
					}										
				});

				_this.appModel._info.app_filters(hrs_tmp[rep_code])
				
				_this.Refresh();
			};

			self.chosenChange	= function($element, params){
				var arr	= null;
				switch($element.attr("id"))
				{
					case "selCL":
						arr=self.CL;
						break;
					case "selIT":
						arr=self.IT;
						break;
					case "selPR":
						arr=self.PR;
						break;
					case "selTT":
						arr=self.TT;
						break;
					case "selUS":
						arr=self.US;
						break;
					case "selEC":
						arr=self.EC;
						break;
					case "selTKS":
						arr=self.TKS;
						break;
				}
				self.chosenCheckAll(arr,$element,params);
			};

			self._info	= {
				projects : Otime.a(data.projects || []),
				task_types : Otime.a(data.task_types || []),
				users : Otime.a(data.users || [])
			};

			self.CL.subscribe(function(newVal){
				Otime.Storage.set("report_filter_CL", newVal);
			});

			self.PR.subscribe(function(newVal){
				Otime.Storage.set("report_filter_PR", newVal);
			});

			self.TT.subscribe(function(newVal){
				Otime.Storage.set("report_filter_TT", newVal);
			});

			self.US.subscribe(function(newVal){
				Otime.Storage.set("report_filter_US", newVal);
			});
			
			self.IT.subscribe(function(newVal){
				Otime.Storage.set("report_filter_IT", newVal);
			});
			
			self.EC.subscribe(function(newVal){
				Otime.Storage.set("report_filter_EC", newVal);
			});
		};

		// flag for restrict _info.view.subscribe
		var flag1	= true;

		_this.ReportModel	= function(data){
			var self	= this;

			data	= data || new Object();

			self._info	= {
				filters : Otime.o(data.filters),
				view : Otime.o(data.view || _this.view || VIEW_SUMMARY),
				report_code : Otime.o(data.report_code || _this.page || REPORT_CODE_TIME),
				group_by : Otime.o(data.group_by || GROUP_BY_CLIENT),
				sort_by: Otime.o(data.sort_by || SORT_BY_DATE),
				is_asc: Otime.o(true),
				date_filter_type : Otime.o(data.date_filter_type || _this.dft || DATE_FILTER_THIS_WEEK),
				date_filter_disp : Otime.o(_this.filter_labels[data.date_filter_type || _this.dft || DATE_FILTER_THIS_WEEK]),
				list_view : Otime.o(data.list_view || "date"),
				period : Otime.o(data.period || ""),
				interval : Otime.o(data.interval || '7'),
				params : Otime.a(data.params || []),
				filter_label : Otime.a(data.filter_label || []),
				outstanding : Otime.a(data.outstanding || []),
				budget_type : Otime.o(data.budget_type || 'H'),
				clients		: Otime.a([]),
				projects	: Otime.a([]),				
				users		: Otime.a([]),
				app_filters	:  Otime.a([])
			};

			self._time	= {
				billable:Otime.o(0),
				non_billable:Otime.o(0),
				invoiced:Otime.o(0),
				un_invoiced:Otime.o(0),
				show_totals:Otime.o(0)
			};

			self._expense	= {
				approved:Otime.o(0),
				unapproved:Otime.o(0),
				total:Otime.o(0)
			};

			self.report_title 	= Otime.o(_this.language["REPORT_TS_TITLE"]);
			self.show_view  	= Otime.o(false);
			self.show_group_by  = Otime.o(false);
			self.show_chart 	= Otime.o(false);
			self.stack			= Otime.o(true);

			self.pieChart	= Otime.a([]);
			self.barChart	= Otime.a([]);
			self.stackedBar	= Otime.a([]);
			self.multiBar	= Otime.a([]);
			self.lineChart	= Otime.a([]);
			self.labels		= Otime.a([]);
			self.colors		= Otime.a([]);
			self.tooltip_params	= Otime.a([]);
			self.ticks		= Otime.a([]);
			
			self._info.interval.subscribe(function(newVal){
				self._info.interval(newVal);
				_this.Refresh();
			});
			
			self._info.budget_type.subscribe(function(newVal){
				_this.Refresh();
			});
			
			self.swap_btype	= function() {
				self._info.budget_type((self._info.budget_type()=='H')?'A':'H');
			}
			self._info.filters_history	= Otime.o({}); 

			self.changeReport	= function(rptCode){
				return function(item, elem){
					self._info.report_code(rptCode);
					_this.appModel._info.group_by('');
					_this.appModel._info.sort_by('');

					if(self._info.report_code()==REPORT_CODE_INVOICE || self._info.report_code()==REPORT_CODE_TIME || self._info.report_code()==REPORT_CODE_BUDGET || self._info.report_code()==REPORT_CODE_EXPENSES)
					{
						if(self._info.view() != VIEW_SUMMARY)
						{
							self._info.view(VIEW_SUMMARY);
							return true;
						}
					}
					Otime.Menu.ReplaceURL(_this.name + "/" + {'T':'time', 'A':'task', 'I':'invoice', 'BU':'budget', 'E':'expenses'}[self._info.report_code()]);
					_this.Refresh();
				};
			};

			/*self.preparelink	= function(){
				return function(item, elem){
					_this.prepareLink();
				};
			};*/

			self.refresh	= function(type){
				return function(item, elem){
					_this.Refresh({'type':type});
				};
			};

			self._info.view.subscribe(function(newVal){
				var report_code	= self._info.report_code() + self._info.view();

				_this.appModel._info.sort_by('');
				self._info.sort_by('');
				switch (report_code) {
					case REPORT_CODE_TASK_SUMMARY:
						if(flag1) {
							Otime.Menu.ReplaceURL(_this.name + "/task/");
						}
					break;
					case REPORT_CODE_INVOICE_DETAIL:
					break;	
					default:
						self._info.period('');
					break;
				}
/*
				if(self._info.params['aging_link'] != '')
				{
					self.report_title(_this.language["REPORT_AGING_DETAIL_TITLE"]);
				}
*/
				flag1 && _this.Refresh();
				flag1	= true;
			});

			self.today	= Otime.o(new Date().format(Otime.jdf));
			self.date	= Otime.o(new Date().format(Otime.jdf));
			self.date_disp	= Otime.o(new Date(self.date()).format(Otime.dateFormat));

			Otime.date_filter(self, _this, function(){
				if (_this.prevent_refresh)
				{
					_this.prevent_refresh	= false; 
					return true;
				}
				var reset_fil = _this.Bookmark.data?false:true;
				if (!reset_fil) {
					_this.appModel._info.filters_history({});
					_this.appModel._info.filters_history()[_this.appModel._info.report_code()] = [];
				}				
				_this.Bookmark.data = "";
				_this.Refresh({}, reset_fil);
			});

			self.columns	= Otime.a([]);
			self.fields		= Otime.a([]);
			self.listingOri	= Otime.a([]);
			self.listing	= Otime.a([]);
			self.total		= Otime.a([]);
			self.clone		= Otime.a([]);
			self.itemsChecked = Otime.a([]);
			self.loading	  =  Otime.o(false);
			
			self.itemsChecked.subscribe(function(newVal) {
				var checked	= self.itemsChecked();
				Otime.Invoice.client_id	= Otime.o(0);
				$.each(checked, function(k,v){
					var ids = v.split("_");
					if(Otime.Invoice.client_id()>0)
					{
						if(Otime.Invoice.client_id()!=ids[0])
						{
							self.itemsChecked([v]);
//							self.itemsChecked()[0] = v;
						}
					}
					Otime.Invoice.client_id(ids[0]);
					//Otime.InvoiceContentModel.is_new(true);
				});
			});

			self.showInvoice = function() {
				if(self.itemsChecked().length>0) {
					Otime.Invoice.project_ids	= Otime.a([]);
					Otime.Invoice.project_names = Otime.a([]);
					Otime.Invoice.date_filter	 = Otime.a([]);
					Otime.Invoice.date_filter({
						date_filter_type:self._info.date_filter_type() , 
						from_date:_this.appModel.date_filter.from_date(), 
						to_date:_this.appModel.date_filter.to_date()
					});
					$.each(self.itemsChecked(), function(k,v) {
						var idsArr = v.split("_");
						Otime.Invoice.project_ids().push(idsArr[1]);
						Otime.Invoice.project_names().push(idsArr[2]);
					});
			
					Otime.app.load_template(Otime.siteUrl + '/invoice', function(response){
						$('#main-container').html(response);
						Otime.Invoice.listModel.addItem();
						return true;
					}, true);
				} else {
					alert("Please select atleast one uninvoiced item!");
				}
			};
			self.calculate	= null;

			self.setGroupBy	= function(val){
				return function(){
					if (self._info.group_by() != val)
					{
						self._info.group_by(val);
						_this.Refresh();
					}
				};
			};

			self._info.list_view.subscribe(function(){
				_this.Refresh();
			});

			self.setListView	= function(val){
				return function(item, value){
					self._info.list_view(val);
				};
			};
			
			self.root_back	= function(item, elem){
				self.back(item,elem, true);
			}
			self.back	= function(item, elem, root){
				root	= root || false;

				if (!root) {
					var item_index	= self._info.filters_history()[_this.appModel._info.report_code()].indexOf(item);
					item_index		= item_index>=0?(1+item_index):item_index;
				} else {
					item_index = 0;
				}
				var sld_arr	= {};

				if (item_index)
				{
					item = self._info.filters_history()[_this.appModel._info.report_code()][item_index];
					sld_arr = self._info.filters_history();
					sld_arr[_this.appModel._info.report_code()] = sld_arr[_this.appModel._info.report_code()].slice(0, item_index)
					self._info.filters_history(sld_arr);
				}
				else
				{
					sld_arr	= self._info.filters_history();
					sld_arr[_this.appModel._info.report_code()]	= [];
					self._info.filters_history(sld_arr);
				}
				flag1	= false;
				_this.Bookmark.set(item.val);
			};

			self.navigateReport	= function(item, elem){
				var obj	= $(elem.delegateTarget).attr("obj");
				var reset = true;
				var fl_gr	= {};
				var ref_params = {};

				if (item)
				{
					var re_type = _this.appModel._info.report_code() + _this.appModel._info.view();
					var start_date = new Date(_this.appModel.date_filter.from_date());
					var end_date   = new Date(_this.appModel.date_filter.to_date());
					var diff = (new Date(end_date - start_date))/864E5;	// 864E5 = 86400000 = 1000*60*60*24
					start_date = end_date =  item.detail_filter;

//					var client_id	= item.CD;
//					var project_id	= item.PN;
//					_this.appModel._info.filters().CL([client_id]);
//					_this.appModel._info.filters().PR([project_id]);
//					self._info.params({
//						client_id : client_id,
//						project_id : project_id
//					});
//					self._info.report_code(REPORT_CODE_BUDGET_DETAIL);
//					_this.Refresh({}, false);

					switch (re_type)
					{
						case REPORT_CODE_INVOICE_SUMMARY:
							if (diff>15 && diff>30)
							{
								start_date 	= new Date(item.detail_filter).getMonthStart();
								end_date 	= new Date(item.detail_filter).getMonthEnd();
							}
							_this.appModel.date_filter.from_date(start_date);
							_this.appModel.date_filter.to_date(end_date);
							flag1	= false;
							self._info.view(VIEW_DETAIL);
							break
						default:
							var gr = _this.appModel._info.group_by();
							var rep_code = _this.appModel._info.report_code();
							if (_this.appModel._info.report_code() == REPORT_CODE_BUDGET) {
								rep_code = REPORT_CODE_BUDGET_DETAIL;
								self._info.filters_history([]);
							}
							var hrs_tmp = self._info.filters_history();
							hrs_tmp[rep_code] = hrs_tmp[rep_code] || [];

							hrs_tmp[rep_code].push({key:(Object.prototype.toString.call(item[gr]) === "[object Date]"?new Date(item[gr]).format(Otime.dateFormat):item[gr]), val:_this.Bookmark.get()});
							self._info.filters_history(hrs_tmp);

							switch(gr)
							{
								case GROUP_BY_EXPENSES_PERIOD:
								case GROUP_BY_DATE:
									if (diff>15 && diff>30)
									{
										start_date 	= new Date(item.detail_filter).getMonthStart();
										end_date 	= new Date(item.detail_filter).getMonthEnd();
									}
									_this.appModel.date_filter.from_date(start_date);
									_this.appModel.date_filter.to_date(end_date);

									if (item[obj] instanceof Date)
									{
										self._info.period(item[obj].format(Otime.jdf));
									}
									else
									{
										self._info.period(item[obj]);
									}
									flag1	= false;
									self._info.view(VIEW_DETAIL);
								break;
								default:
									// group by filter

									switch (_this.appModel._info.report_code()) {
										case REPORT_CODE_TIME:
											fl_gr	= {
												CL: GROUP_BY_PROJECT,
												PR: GROUP_BY_TASK_TYPE,
												TT: GROUP_BY_USER,
												US: GROUP_BY_DATE
											};
										break;
										case REPORT_CODE_EXPENSES:
											fl_gr	= {
												CL: GROUP_BY_PROJECT,
												PR: GROUP_BY_USER,
												US: GROUP_BY_EXPENSES_CATEGORY,
												EC: GROUP_BY_EXPENSES_PERIOD
											};
										break;
										case REPORT_CODE_BUDGET:
											reset = false;		
											item.detail_filter = item.PN;
											self._info.report_code(REPORT_CODE_BUDGET_DETAIL);
										break;
										case REPORT_CODE_BUDGET_DETAIL:
											reset = false;
											item.detail_filter = item.TI;
											flag1	= false;
											self._info.report_code(REPORT_CODE_TIME_DETAIL);
										break;
										case REPORT_CODE_TASK:
											self._info.report_code(REPORT_CODE_TASK_DETAIL);
											flag1	= false;
											reset = false;
										break;
									}
									// PK group validation for task detail from task summary
									//if (gr!='PK' && _this.appModel._info.filters()[gr]) {
									if (!_this.appModel._info.filters()[gr]) {
										_this.appModel._info.filters()[gr] = Otime.o("");
									}
									_this.appModel._info.filters()[gr]([item.detail_filter]);
									/*} else {
										ref_params = {};
										ref_params[gr] = item.detail_filter;
									}*/
				
									gr	= (fl_gr[gr] != undefined) ? fl_gr[gr] : gr;
							}
							_this.appModel._info.group_by(gr);
					}
				}
				_this.Refresh(ref_params, reset);
			};

			self.showDetail = function(item, elem){
				var obj	= $(elem.delegateTarget).attr("obj");
				item.CC && self._info.params({
					currency_code: item.CC
				});
				if (item[obj] instanceof Date)
				{
					self._info.period(item[obj].format(Otime.jdf));
				}
				else
				{
					self._info.period(item[obj]);
				}
				self._info.view(VIEW_DETAIL);
			};

			self.model_timesheet	= Otime.o(null);
			self.view_hours_mode 	= Otime.o(false);
			self.view_expense_mode 	= Otime.o(false);
			self.approve_hours = function(project_id, client_id) {
				var list_container_new	= $('#hours_approve .modal-body');

				if (!self.model_timesheet())
					self.model_timesheet(new Otime.TimeSheetApprove.TimesheetApproveModel());;
				
				if (!Otime.app.hasBinding(list_container_new))
				{
					Otime.app.load_template(Otime.siteUrl + "/" + Otime.TimeSheetApprove.name + "/approve/1", function(response){
						list_container_new.html($.trim(response));
						self.model_timesheet().popup_close = function(){
							_this.Refresh();
							$("#hours_approve").modal('hide');
						}; 
						ko.applyBindings(self.model_timesheet, $('#hours_approve .modal-content').get(0));
						self.approve_hours(project_id, client_id);
					}, true);
					return true;
				}
				var post_data = {'project_id':project_id, 'client_id':client_id, 'billable': 1};
				$.extend(post_data, {
					from_date : new Date(_this.appModel.date_filter.from_date()).format(Otime.sdf),
					to_date : new Date(_this.appModel.date_filter.to_date()).format(Otime.sdf)
				});
				
				Otime.app.loadData(new Otime.ContextModel(Otime.siteUrl + "/" + Otime.TimeSheetApprove.name +'/project_timesheet', post_data, function(cont){
					self.model_timesheet().load(cont);
					$("#hours_approve").modal('show');
				}), true);
			};
			self.hours_close = function() {
				self.view_hours_mode(false);
			};
			self.expense_close = function() {
				self.view_expense_mode(false);
			};
			self.uninvoice_view = function(project_id, client_id, view) {
				self._info.params({project_id: project_id, client_id: client_id});
				self._info.report_code(VIEW_UNINVOICED);
				self._info.view(view);
			};
			self.show_summary = function(rep_code, view) {
				self._info.report_code(rep_code);
				self._info.view(view);
			};
			self.model_expenses	= Otime.o({
				project_id: Otime.o(0),
				approve_total_amount: Otime.o(0),
				appr_listing: Otime.a([]),
				popup_close: function(){
					_this.Refresh();
					$("#expenses_approve").modal('hide');
				},
				approve_entry: function(item){
					var data	= {
						project_id: self.model_expenses().project_id()
					};
					if(item.hasOwnProperty('expense_id'))
					{
						data.expense_id	= item.expense_id();
					}
					var context	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.Expenses.name +'/approve', data, function(context){
						response	= context.response;
						self.approve_exp();
					});
					Otime.app.postData(context, true);

					return true;
				}
			});

			self.budget_detail	= function(item){
				var client_id	= item.CD;
				var project_id	= item.PN;

				_this.appModel._info.filters().CL([client_id]);
				_this.appModel._info.filters().PR([project_id]);
				self._info.params({
					client_id : client_id,
					project_id : project_id
				});
				self._info.report_code(REPORT_CODE_BUDGET_DETAIL);
				_this.Refresh({}, false);
			};

			self.invDetail	= function(project_id, client_id, task_type_id, task_finish_date){
				self._info.report_code(REPORT_CODE_TIME_DETAIL);
				_this.appModel._info.filters().CL([client_id]);
				_this.appModel._info.filters().PR([project_id]);
				_this.appModel._info.filters().TT([task_type_id]);
				_this.Refresh({}, false);
			};

			self.approve_expenses	= function(project_id, client_id){
				var list_container_new	= $('#expenses_approve .modal-body');

				if (!Otime.app.hasBinding(list_container_new))
				{
					Otime.app.load_template(Otime.siteUrl + "/" + Otime.Expenses.name + "/index/1", function(response){
						list_container_new.html($.trim(response));
						ko.applyBindings(self.model_expenses, $('#expenses_approve .modal-content').get(0));
						self.approve_expenses(project_id, client_id);
					}, true);
					return true;
				}
				self.model_expenses().project_id(project_id);
				
				self.approve_exp();
				$("#expenses_approve").modal('show');
			};
			self.approve_exp = function() {
				var post_data = {
					filter_project_id: self.model_expenses().project_id()
				};
				if (self._info.date_filter_type() != 'ALL') {
					$.extend(post_data, {
						start_date : new Date(_this.appModel.date_filter.from_date()).format(Otime.sdf),
						finish_date : new Date(_this.appModel.date_filter.to_date()).format(Otime.sdf)
					});
				}
				var cont	= new Otime.ContextModel(Otime.siteUrl + "/" + Otime.Expenses.name + "/project_expenses/approve", post_data, function(cont_items){
					var apprItems	= [],
						appr_total	= 0;
					if(cont_items.response.approve_items.otvalues != undefined) {
						cont_items.response.approve_items	= cont_items.response.approve_items.otvalues.setKeys(cont_items.response.approve_items.otkeys, function(item){
						apprItems.push(new Otime.Expenses.ExpenseDetailModel(item));
						appr_total	+= parseFloat(item.amount || 0);
					});
					
					}
					self.model_expenses().appr_listing(apprItems);
					self.model_expenses().approve_total_amount(appr_total);
				});
				Otime.app.loadData(cont, true);
			};

			self.agingDetail = function(val, client_id, currency_code) {
				self._info.params({client_id:client_id, currency_code:currency_code, aging_link:val});
				self._info.view('O');
			};

			self.invoiceDetail	= function(item){
				var invoice_id	= item.invoice_id-0;
				Otime.app.load_template(Otime.siteUrl + '/invoice/unpaid/'+invoice_id, function(response){
					$('#main-container').html(response);
					Otime.Invoice.listModel.addItem();
					return true;
				}, true);
			};

			self.apply		= function(item){
				var columns	= {};
				$.each(self.columns(), function(key, val){
					if (val.type != "AL")
					{
						columns[val.name]	= Number(val.enabled());
					}
				});

				var report_code	= _this.appModel._info.report_code() || "";
				/*if (_this.appModel._info.report_code() != REPORT_CODE_TASK)
				{*/
					report_code	+= _this.appModel._info.view();
				/*}*/
				
				if (_this.appModel._info.group_by() && columns[_this.appModel._info.group_by()])
					delete columns[_this.appModel._info.group_by()];
				Otime.app.postData(new Otime.ContextModel("save", {
					'report_code' : report_code.substr(0, 2),
					'report_columns' : JSON.stringify(columns),
					'date_filter_type' : DATE_FILTER_THIS_WEEK,
					'sort_by' : SORT_BY_DATE
				}, function(cont){
					_this.Refresh();
				}));
			};

			self.sort	= function(sort_by){
				return function(item, elem){
					self._info.sort_by(sort_by);

					if (_this.appModel.clone().length <= 0)
					{
						_this.appModel.clone(_this.appModel.listing().slice());
					}

					var arr	= self.listing().sort(function(a, b){
						var x	= isNaN(a[sort_by]) ? a[sort_by].toLowerCase() : Number(a[sort_by]),
							y	= isNaN(b[sort_by]) ? b[sort_by].toLowerCase() : Number(b[sort_by]);

						return x < y ? -1 : x > y ? 1 : 0;
					});

					if (!self._info.is_asc())
					{
						arr.reverse();
					}

					self.listing(arr);
					self._info.is_asc(!self._info.is_asc());
				};
			};

			self.compute	= Otime.c(function(){
				if (typeof self.calculate == "function")
				{
					self.calculate(self);
				}
			});

			self.isPinned	= Otime.o(!!Otime.Storage.get("report_panel_isPinned"));
			self.swapPin	= function(){
				self.isPinned(!self.isPinned());
				Otime.Storage.set("report_panel_isPinned", self.isPinned());

				// Re-Render the chats to avoid small or big size.
				_this.appModel.pieChart.valueHasMutated();
				_this.appModel.barChart.valueHasMutated();
				_this.appModel.stackedBar.valueHasMutated();
				_this.appModel.lineChart.valueHasMutated();
			};

			self.isPannel	= Otime.o(self.isPinned() || false);
			self.swapPanel	= function(){
				self.isPannel(!self.isPannel());
			};

			var handle	= null;
			$("#left-panel").bind({
				mouseenter: function(){
					clearTimeout(handle);
					self.isPannel(true);
				},
				mouseleave: function(){
					handle	= setTimeout(function(){
						self.isPannel(false);
					}, 750);
				}
			});
		};

		_this.ReportColumns	= function(data){
			var self	= this;

			data	= data || {};

			self.name		= data.name || "";
			self.label		= data.label || "";
			self.type		= data.type || VIEW_SUMMARY;
			self.visible	= data.visible;
			self.left_col_visible = (data.left_col_visible && data.type !="AL") ;
			self.enabled	= Otime.o(data.visible);
			self.enabled.subscribe(function(newVal){
				_this.appModel.apply(self);
				if (_this.appModel._info.group_by() == self.name && !newVal)
				{
					self.enabled(true);
				}
			});
			self.is_sorted	= Otime.o(false);
			self.is_asc		= Otime.o(true);

//			self.chkEnabled	= Otime.c(function(){
//				return self.enabled() || _this.appModel._info.group_by() == self.name;
//			});
		};

		_this.ReportContentModel	= function(data){
			var self	= this;
		};

		_this.ApplyReport	= function(data){
			if (!data)
			{
				return false;
			}
//console.log("Callback Start : ", new Date().getTime());

			var columns	= data.columns || [],
				fields = data.fields || [],
				items	= data.items,
				total	= data.total || null,
				chart	= data.chart || null,
				details	= data.details || null,
				time_details	= data.time_details || null,
				filter_label	= data.filter_label || [],
				outstanding		= data.outstanding || [];
				_this.appModel.show_chart(false);

			var tmpArr	= [];
			
			_this.appModel._time.show_totals(0);

			switch(data.report_code)
			{
				case REPORT_CODE_TIME_SUMMARY:
				case REPORT_CODE_TIME_DETAIL:
					if (chart) {
						_this.appModel._time.billable(Number(chart.billable));
						_this.appModel._time.non_billable(Number(chart.non_billable));
						_this.appModel._time.invoiced(Number(chart.invoiced));
						_this.appModel._time.un_invoiced(Number(chart.un_invoiced));
						_this.appModel._time.show_totals(1);
					}
					_this.Chart.Time(chart, items);
					break;
				case REPORT_CODE_TASK_SUMMARY:
					_this.Chart.Task(chart, items);
				case REPORT_CODE_TASK_MILESTONE:
				case REPORT_CODE_TASK_DETAIL:
					_this.Chart.Task(chart, items);
					break;
				case REPORT_CODE_INVOICE_SUMMARY:
					_this.Chart.Invoice(chart, items);
					break; 	
				case REPORT_CODE_EXPENSES_SUMMARY:
				case REPORT_CODE_EXPENSES_DETAIL:
					_this.Chart.Expense(chart, items);
					break;
				case REPORT_CODE_BUDGET:
					_this.Chart.Budget(chart, items);
					break;
				case REPORT_CODE_INVOICE_OUTSTANDING:
					var col = ["invoice_id","Invoice Id", 0, "HIDDEN", 0, 0];
					columns.push(col);
					break;
				case REPORT_CODE_INVOICE_AGGING:
					var tmp_items = {}, tmp_details = {};
					$.each(items, function(key, val){
						if (tmp_items[val.CN]) {
							val.CL = '';
						}

						val.TL = Number(val.CT) + Number(val.T1) + Number(val.T2) + Number(val.T3);
						val.TL = val.TL.toFixed(2);
						tmp_items[val.CN] = true;
					});
					
					/*items = tmp_items;
					details = tmp_details;*/
					break;
			}
			
			if (data.report_code)
			{
				if (data.report_code != REPORT_CODE_BUDGET && data.report_code != REPORT_CODE_BUDGET_DETAIL)
				{
					data.report_code	= data.report_code.split("");
					_this.appModel._info.report_code(data.report_code[0]);
					_this.appModel._info.view(data.report_code[1]);
				}
				else
				{
					_this.appModel._info.report_code(data.report_code);
					//_this.appModel._info.view("");
				}
			}
			_this.appModel._info.filter_label(filter_label);
			_this.appModel._info.outstanding(outstanding);

			if (columns.length)
			{
				tmpArr	= [];
				var obj	= null;

				for(var j=0; j<columns.length; j++)
				{
//					if (data.view == VIEW_DETAIL && data.group_by == columns[j][0])
//					{
//						columns[j][2] = false;
//					}
					obj	= {
						name	: columns[j][0],
						label	: columns[j][1] || columns[j][0],
						type	: columns[j][3].toUpperCase(),
						visible	: Boolean(columns[j][2]),
						left_col_visible : Boolean(columns[j][4])
					};

//					if(obj.type == VIEW_DETAIL)
//					{
//						tmpArr.push(new _this.ReportColumns({
//							name : obj.name + "_display",
//							label : obj.label,
//							type : "AL", // Alias
//							visible : Boolean(obj.visible),
//							left_col_visible : Boolean(obj.left_col_visible)
//						}));
//					}

					tmpArr.push(new _this.ReportColumns(obj));
				}
				_this.appModel.columns(tmpArr.slice());
			}

			if (fields.length)
			{
				tmpArr	= [];
				for(var j=0; j<fields.length; j++)
				{
					var obj	= {
						name	: fields[j][0],
						label	: fields[j][1] || fields[j][0],
						type	: fields[j][3].toUpperCase(),
						visible	: Boolean(fields[j][2]),
						left_col_visible : Boolean(fields[j][4])
					};
					tmpArr.push(new _this.ReportColumns(obj));
				}
				_this.appModel.fields(tmpArr.slice());
			}

			_this.appModel.columns(tmpArr.slice());
			_this.appModel.listing([]);
			_this.appModel.total([]);
			tmpArr	= [];

			var keys	= Object.keys(items);

			for (var i=0; i<keys.length; i++)
			{
				var reportContent	= new _this.ReportContentModel();
				for(var j=0; j<columns.length; j++)
				{
					var name	= columns[j][0],
						type	= columns[j][3].toUpperCase(),
						visible	= Boolean(columns[j][2]),
						left_col_visible	= Boolean(columns[j][4]);

					if (!visible && data.group_by != name && type != "HIDDEN")
						continue;

					if (type == "HIDDEN")
					{
						reportContent[name]	= items[keys[i]][name];
						continue;
					}

					if(type == VIEW_DETAIL)
					{
						var _tmp	= Otime.stoj(items[keys[i]][name]);
						reportContent[name]	= (_tmp+"" == "Invalid Date") ? items[keys[i]][name] : _tmp;//.format(Otime.dateFormat);
//						reportContent[name + "_display"]	= new Date(items[keys[i]][name]).format(Otime.dateFormat);
					}
					else
					{
						if(type == DATA_TYPE_NUMBER || type == DATA_TYPE_CURRENCY)
							reportContent[name]	= isNaN(items[keys[i]][name]) ? items[keys[i]][name] : Number(items[keys[i]][name]).toFixed(2) || "";
						else
							reportContent[name]	= items[keys[i]][name];
					}

//					
					if(name == GROUP_BY_DATE || name == GROUP_BY_EXPENSES_PERIOD || name == GROUP_BY_INVOICE_PERIOD)
					{
						var _tmp	= new Date(items[keys[i]][name]);
						reportContent[name]	= (_tmp+"" == "Invalid Date") ? items[keys[i]][name] : _tmp;//.format(Otime.dateFormat);

//						reportContent[name]	= new Date(items[keys[i]][name]);
//						reportContent[name + "_display"]	= new Date(items[keys[i]][name]).format(Otime.dateFormat);
//						reportContent[name + "_display"]	= (reportContent[name + "_display"])?reportContent[name + "_display"]:items[keys[i]][name];
						reportContent[name]	= (reportContent[name])?reportContent[name]:items[keys[i]][name];
					}

					if(name == GROUP_BY_INVOICE_STATUS)
					{
					//	console.log(name);
						reportContent[name]	= _this.status[items[keys[i]][name]];
						reportContent[name + '_class_name'] = _this.status_class[items[keys[i]][name]];
					}

					if(data.view == VIEW_DETAIL && data.group_by != name && reportContent[data.group_by])
					{
						var group_val = reportContent[data.group_by];
						var report_keys = Object.keys(reportContent);

//						if (reportContent[data.group_by + "_display"])
//						{
//							group_val = reportContent[data.group_by + "_display"];
//							reportContent[data.group_by+ "_display"]	= null;
//						}

						var index_key	= report_keys.indexOf(data.group_by);						
						if (index_key >0)
						{
							index_key = -1;
						}
//						else if (report_keys.indexOf(data.group_by+'_display') >= 0)
//						{
//							index_key = report_keys.indexOf(data.group_by+'_display');
//						}
						index_key++;

						// delete reportContent[data.group_by];
						reportContent[data.group_by]	= null;
						reportContent[report_keys[index_key]] = group_val;
//						if (reportContent[report_keys[index_key]+'_display'] != 'undefined')
//						{
//							reportContent[report_keys[index_key]+'_display'] = group_val;
//						}
					}
				}

				if (reportContent["FH"])
				{
					reportContent["OD"]	= (Otime.Date(reportContent["FH"]).clearTime().getTime() < Otime.Date().clearTime().getTime()) && !(items[i].is_closed-0);
				}

				for(var j=0; j<fields.length; j++)
				{
					var name	= fields[j][0],
						type	= fields[j][3].toUpperCase(),
						visible	= Boolean(fields[j][2]),
						left_col_visible = Boolean(fields[j][4]);

//						if (!visible && data.group_by!=name)
//							continue;
					
					reportContent[name]	= (type==VIEW_SUMMARY || isNaN(items[keys[i]][name])) ? items[keys[i]][name] : Number(items[keys[i]][name]).toFixed(2) || "";
				}

				if (details && details[keys[i]])
				{
					reportContent.details	= Otime.a([]);
					for (var k=0,kLen=details[keys[i]].length; k<kLen; k++)
					{
						var detailsList	= new _this.ReportContentModel();
						for(var j=0,jLen=columns.length; j<jLen; j++)
						{
							var name	= columns[j][0],
								type	= columns[j][3].toUpperCase(),
								visible	= Boolean(columns[j][2]),
								left_col_visible	= Boolean(columns[j][4]);

							if (!visible || name == data.group_by)
								continue;

							if (name == REPORT_COL_START_AND_END_TIME)
							{
								if (time_details && time_details[details[keys[i]][k][name]])
									detailsList[name]	= time_details[details[keys[i]][k][name]].join("\n").replace(/,/g, " - ");
								continue;
							}

							if(type == VIEW_DETAIL && data.group_by != GROUP_BY_DATE)
							{
								var _tmp	= new Date(details[keys[i]][k][name]);
								detailsList[name]	= (_tmp+"" == "Invalid Date") ? details[keys[i]][k][name] : _tmp//.format(Otime.dateFormat);
//								detailsList[name + "_display"]	= new Date(details[keys[i]][k][name]).format(Otime.dateFormat);
							}
							else // if(data.group_by != GROUP_BY_DATE)
							{
								if(type == DATA_TYPE_NUMBER || type == DATA_TYPE_CURRENCY)
									detailsList[name]	= isNaN(details[keys[i]][k][name]) ? details[keys[i]][k][name] : Number(details[keys[i]][k][name]).toFixed(2) || "";
								else
									detailsList[name]	= details[keys[i]][k][name];
							}

							if (name == "FH")
							{
								detailsList["OD"]	= (Otime.Date(detailsList[name]).clearTime().getTime() < Otime.Date().clearTime().getTime()) && !(items[i].is_closed-0);
							}
						}
						reportContent.details.push(detailsList);
					}
				}
				tmpArr.push(reportContent);
			}

//console.log("Start : ", new Date().getTime());
//			_this.lstFrom	= 0;
//			_this.appModel.listing([]);
//			_this.appModel.listingOri(tmpArr.slice());
//			_this.nextPage(25);
			_this.appModel.listing(tmpArr.slice());
//console.log("End : ", new Date().getTime());
			_this.appModel.total(total);
		};

		_this.nextPage	= function(count){
			count	= count || _this.lstCount || 15;
console.log("Called", _this.lstFrom, count, _this.appModel.listing(), _this.appModel.listingOri());
			_this.appModel.listing.append(_this.appModel.listingOri().slice(_this.lstFrom, count));
			_this.lstFrom	+= count;
		};

		_this.Chart	= {
			Time: function(chart, items){
				var tmpArr = [];
				// var hrs = [];
				var bhrs = [];
				var nbhrs = [];
				var date =0;
				var label = [];
				var tooltip_params = [];
				var k=0;
				var diff = 0;

//				if(Object.keys(items).length>0) 
//				{
					if (_this.appModel._info.group_by() == GROUP_BY_DATE)
					{
						var tmp_label = [];

						var start_date = new Date(_this.appModel.date_filter.from_date());
						var end_date   = new Date(_this.appModel.date_filter.to_date());
						diff = (new Date(end_date - start_date))/1000/60/60/24;
						var sql_date 	=  new Date();

						while (end_date.isAfter(start_date) || !end_date.isBefore(start_date))
						{
							sql_date	= start_date.format(Otime.sdf);
							if (diff>100)
							{
								sql_date	= _this.month_names_short[start_date.getMonth()];
							} else if (diff>6 && diff <=31) {
								sql_date	= start_date.getDate();
							} else {
								tooltip_params[k] = start_date.format(Otime.sdf);
							}

							bhrs[sql_date]	= [k,0];
							nbhrs[sql_date]	= [k,0];
							tmp_label[k]	= sql_date;

							if (diff>100)
							{
								start_date	= start_date.addMonth(1)
							} else {
								start_date	= start_date.addDays(1);
							}
							
							label.push([k, sql_date]);
							k++;
						}

						if (items && Object.values(items).length > 0)
						{
							var date_index;
							$.each(items, function(key, row){
								key	= Number(row.DA)?Number(row.DA):row.DA;
								var tmp_date = new Date(row.DA);
								if (diff>100)
								{
									key	= _this.month_names_short[tmp_date.getMonth()];
								} else if (diff>6 && diff <=31) {
									key	= tmp_date.getDate();
								}

								date_index	= tmp_label.indexOf(key);
								if (bhrs[key]) {
									row.BH = (bhrs[key][1] -0) + (row.BH - 0);
									row.NH = (nbhrs[key][1] -0) + (row.NH - 0);
								}
								bhrs[key]	= [date_index, row.BH];
								nbhrs[key]	= [date_index, row.NH];
							});
						}

						bhrs = Object.values(bhrs);
						nbhrs = Object.values(nbhrs);
					}
					else
					{
						$.each(items, function(key, val){
							bhrs.push([k, val.BH]);
							nbhrs.push([k, val.NH]);
							label.push([k, val[_this.appModel._info.group_by()]]);
							k++;
						});
					}

					//tmpArr.push({label:'Hours', data:hrs});
					tmpArr.push({label:'Billable Hours', data:bhrs});
					tmpArr.push({label:'Non-Billable Hours', data:nbhrs});
					// var colors = ['#0088CC', '#5CB85C','#D9534F'];
					var colors = ["#52D793","#FC8660"];
					_this.appModel.stack(true);
					_this.appModel.colors(colors);
					_this.appModel.tooltip_params(tooltip_params);
					_this.appModel.ticks(label);
					_this.appModel.stackedBar(tmpArr.slice());
					if(Object.keys(items).length>0) 
						_this.appModel.show_chart(true);
					if (diff < 100 && diff > 31)
						$('.flot-x-axis .tickLabel').css('display','none');
				//}
			},
			Task: function(chart, items){
				var tmpArr	= [],
					colors = [];

				if(chart)
				{
					var tmpArr  = [], tt_name = [], label = [], t_index=0;
					var tmpArr2 = {};
					var an = 0;
					if (_this.appModel._info.report_code() + _this.appModel._info.view() != REPORT_CODE_TASK_SUMMARY) {
						an = 0;
						$.each(chart, function(key, value){						
							var name_split = key.split("__");
							label.push([an,name_split[1]]);
							$.each(value, function(k, v){
								if (!k) return false;
								if (!tmpArr2[k])
								{
									// tmpArr2[k] = [tmp_data];
									tmpArr2[k] = [];
								}
								tmpArr2[k][an]	= [an,v.hours];
							});
							an++;
						});

						if(Object.keys(tmpArr2).length>0)
						{
							$.each(tmpArr2, function(k, v){
								tmpArr.push({label:k, data:v});
							});
						}
						_this.appModel.show_chart(true);
						colors = ['#FA5C43', '#00BCF2','#52B043','#F7AF33','#A551BA','#00ABA9','#A05000','#208ed3','#ABABAB'];
						_this.appModel.stack(true);
						_this.appModel.colors(colors);
						_this.appModel.stackedBar(tmpArr);
						_this.appModel.ticks(label);
					} else {
						$.each(chart['piechart'], function(key, value){
							tmpArr.push({label:key, data:Number(value['percent'])});
						});
						if(tmpArr.length>0)
							_this.appModel.show_chart(true);

						_this.appModel.pieChart(tmpArr.slice()); 

						// var tmp_data = [];
						var chart_types  = Object.keys(chart['barchart']);
						for (an =0;an<chart_types.length;an++)
						{
							//tmp_data.push([an,0]);
							label.push([an,chart_types[an]]);
						}
						an = 0;
						$.each(chart['barchart'], function(key, value){						
							$.each(value, function(k, v){
								if (!k) return false;
								if (!tmpArr2[k])
								{
									// tmpArr2[k] = [tmp_data];
									tmpArr2[k] = [];
									colors.push(v['color']);
								}
								tmpArr2[k][an]	= [an,v.percent];
							});
							an++;
						});

						if(Object.keys(tmpArr2).length>0)
						{
							$.each(tmpArr2, function(k, v){
								tmpArr.push({label:k, data:v});
							});
						}

						if(tmpArr.length>0)
							_this.appModel.show_chart(true);
					}
					// Should be Task background color from entity settings.
					_this.appModel.colors(colors);
					_this.appModel.stackedBar(tmpArr);
					_this.appModel.ticks(label);
				}
			},
			Invoice: function(chart, items){
				var tmpArr	= [],
					label	= [],
					due		= [],
					overdue	= [],
					paid	= [];

				var k	= 0;
				if(chart)
				{
					var tmp_label = [];
					var start_date = new Date(_this.appModel.date_filter.from_date());
					var end_date   = new Date(_this.appModel.date_filter.to_date());
					var diff = (new Date(end_date - start_date))/1000/60/60/24;
					var sql_date 	=  new Date();
					
					while (end_date.isAfter(start_date) || !end_date.isBefore(start_date))
					{
						sql_date = start_date.format(Otime.sdf);
						if (diff>30) {
							sql_date = _this.month_names_short[start_date.getMonth()];
						}
						
						due[sql_date] 		= [k,0];
						overdue[sql_date] 	= [k,0];
						paid[sql_date] 		= [k,0];
						tmp_label[k]		= sql_date;
						
						if (diff>30)
						{
							start_date = start_date.addMonth(1)
						}
						else
						{
							if (diff>6 && diff<=30)
							{
								sql_date = start_date.getDate();
							}
							else
							{
								sql_date = new Date(sql_date).format(Otime.dateFormat);
							}
							start_date = start_date.addDays(1);
						}
						
						label.push([k, sql_date]);
						k++;
					}		
					var date_index	= null;
					$.each(chart, function(key, val){
						key	= Number(key) ? Number(key) : key;
						date_index	= tmp_label.indexOf(key);
						due[key] 	= [date_index, val['due'] ? val['due'] : 0];
						paid[key] 	= [date_index, val['paid'] ? val['paid'] : 0];
						overdue[key] = [date_index, val['overdue'] ? val['overdue'] : 0];
					});
					due = Object.values(due);
					paid = Object.values(paid);
					overdue = Object.values(overdue);

					tmpArr.push({label:'Due', data:due});
					tmpArr.push({label:'Paid', data:paid});
					tmpArr.push({label:'Over Due', data:overdue});
					var colors = ['#FCB660', '#008000','#FF0000'];

					_this.appModel.stack(true);
					_this.appModel.colors(colors);
					_this.appModel.ticks(label);
					_this.appModel.stackedBar(tmpArr.slice());
					_this.appModel.show_chart(true); 
				}
			},
			Expense: function(chart, items){ 
				var k	= 0,
					at = 0,
					aa = 0,
					ua = 0,
					tmpArr		= [],
					total_amt	= [],
					label		= [],
					approved_amt	= [],
					unapproved_amt	= [];

				if(items.length>0 || Object.keys(items).length>0)
				{
					if (_this.appModel._info.group_by() == GROUP_BY_EXPENSES_PERIOD)
					{
						var tmp_label = [];
						var start_date = new Date(_this.appModel.date_filter.from_date());
						var end_date   = new Date(_this.appModel.date_filter.to_date());
						var diff = (new Date(end_date - start_date))/1000/60/60/24;
						var sql_date 	=  new Date();
					
						while (end_date.isAfter(start_date) || !end_date.isBefore(start_date))
						{
							sql_date = start_date.format(Otime.sdf);
							if (diff>30) {
								sql_date = _this.month_names_short[start_date.getMonth()];
							}

							tmp_label[k]		= sql_date;
						
							if (diff>30)
							{
								start_date = start_date.addMonth(1)
							}
							else
							{
								if (diff>6 && diff<=30)
								{
									sql_date = start_date.getDate();
								}
								else
								{
									sql_date = new Date(sql_date).format(Otime.dateFormat);
								}
								start_date = start_date.addDays(1);
							}
						
							label.push([k, sql_date]);
							k++;
						}

						var date_index	= null;
						if (items && Object.values(items).length > 0)
						{
							var date_index;
							$.each(items, function(key, row){
								key	= Number(row.XP)?Number(row.XP):row.XP;
								var tmp_date = new Date(key);
								if (diff>30)
								{
									key	= _this.month_names_short[tmp_date.getMonth()];
								}

								date_index	= tmp_label.indexOf(key);

								at = at + Number(row.AT);
								aa = aa + Number(row.AA);
								ua = ua + Number(row.UA);

								if (approved_amt[key]) {
									row.AA = (approved_amt[key][1] -0) + (row.AA - 0);
									row.UA = (unapproved_amt[key][1] -0) + (row.UA - 0);
								}

								total_amt[key] 	= [date_index, row.AT];
								approved_amt[key]	= [date_index, row.AA];
								unapproved_amt[key]	= [date_index, row.UA];

							});
						}

						approved_amt = Object.values(approved_amt);
						unapproved_amt = Object.values(unapproved_amt);
					}
					else
					{
						$.each(items, function(key, val){
							approved_amt.push([k, val.AA-0]);
							unapproved_amt.push([k, val.UA-0]);

							label.push([k, val[_this.appModel._info.group_by()]]);

							at = at + Number(val.AT);
							aa = aa + Number(val.AA);
							ua = ua + Number(val.UA);
							k++;
						});
					}

					tmpArr.push({label:'Approved', data:approved_amt});
					tmpArr.push({label:'Un-Approved', data:unapproved_amt});
					var colors = ["#52D793","#FC8660"];

					_this.appModel.colors(colors);
					_this.appModel.ticks(label);
					_this.appModel.multiBar(tmpArr);
					_this.appModel.show_chart(true);
				}

				_this.appModel._expense.approved(aa);
				_this.appModel._expense.unapproved(ua);
				_this.appModel._expense.total(at);

			},
			Budget: function(chart, items){ 
				var k	= 0,
					tmpArr	= [],
					bud_per	= [],
					act_per	= [],
					label	= [];

				if(items.length > 0)
				{
					$.each(items, function(key, val){
						bud_per.push([k, Number(val.BU)]);
						act_per.push([k, Number(val.AC)]);
						label.push([k, val.PR]);
						k++;
					});
					tmpArr.push({label:'budget', data:bud_per});
					tmpArr.push({label:'actual', data:act_per});
					var colors = ["#52D793","#FC8660"];
					//_this.appModel.stack(true);
					_this.appModel.colors(colors);
					_this.appModel.ticks(label);
					//_this.appModel.stackedBar(tmpArr.slice());
					_this.appModel.multiBar(tmpArr.slice());
					_this.appModel.show_chart(true); 
				}
			}
		};

		_this.prepareLink = function(){
			var ret	= JSON.parse(ko.toJSON(_this.appModel._info.filters()));
			var url = '';
			$.each(ret, function(key, row){
				if (key!='_info' && row!='all') {
					url+= url?'&':'?';
					url+= key+'='+row;
				}
			});
			url+= url?'&':'?';
			url+='dt_ty='+_this.appModel._info.date_filter_type();
			url+='&fd='+encodeURIComponent(_this.appModel.date_filter.from_date());
			url+='&td='+encodeURIComponent(_this.appModel.date_filter.to_date());
			url+='&gb='+_this.appModel._info.group_by();
			url+='&sb='+_this.appModel._info.sort_by();
			url+='&rc='+_this.appModel._info.report_code();
			url+='&rv='+_this.appModel._info.view();

			url = _this.name + "/" + {'T':'time', 'A':'task', 'I':'invoice', 'BU':'budget', 'E':'expenses'}[_this.appModel._info.report_code().substr(0, 1)] + url;
			Otime.Menu.ReplaceURL(url);
		};

		_this.Refresh	= function(arg_params, reset){
			var startTime	= new Date().getTime();
			reset	= (reset == undefined ? true : reset);
			arg_params	= arg_params || {};
/*console.log(_this.appModel._info.report_code());
			if (_this.appModel._info.report_code()==REPORT_CODE_TASK && _this.appModel._info.view()==VIEW_SUMMARY) {
				var tmp = location.href.split('/');

				if (tmp[6]) {
					flag1 =false;
					_this.appModel._info.view(VIEW_DETAIL);
					arg_params.PK = tmp[6];
				}
			}
console.log(arg_params);*/
			if (reset && !_this.appModel._info.filters_history()[_this.appModel._info.report_code()])
			{
				_this.prevent_refresh = true;
				var new_item = {CL:["all"], PR:["all"], US:["all"], TT:["all"]};
				_this.Bookmark.set(new_item);
				_this.appModel._info.filters_history({});
				_this.appModel._info.filters_history()[_this.appModel._info.report_code()] = [];
				_this.appModel._info.app_filters([]);
			}

			var data	= JSON.parse(ko.toJSON(_this.appModel._info.filters) || "{}");
			var params	= JSON.parse(ko.toJSON(_this.appModel._info.params) || "{}");
			var arg_params	= arg_params || {};
			var type = (arg_params.type!=undefined?('/'+arg_params.type):'');

			if (!type)
			{
				_this.appModel.pieChart([]);
				_this.appModel.barChart([]);
				_this.appModel.stackedBar([]);
				_this.appModel.lineChart([]);
				_this.appModel.labels([]);
				_this.appModel.listing([]);
				_this.appModel.loading(true);
			}

			if(_this.appModel._info.period() != '')
			{
				var filter_dates	= _this.appModel._info.period().split(" - ");
				if(!filter_dates[1])
					filter_dates[1]	= filter_dates[0];
				_this.appModel.date_filter.from_date(Otime.stoj(filter_dates[0]));
				_this.appModel.date_filter.to_date(Otime.stoj(filter_dates[1]));
			}

			$.extend(data, {
				from_date : new Date(_this.appModel.date_filter.from_date()).format(Otime.sdf),
				to_date : new Date(_this.appModel.date_filter.to_date()).format(Otime.sdf)
			});

			var reportCode	= (_this.appModel._info.report_code() + _this.appModel._info.view()).substr(0, 2);
			_this.appModel.report_title(_this.language["REPORT_"+reportCode+"_TITLE"]);

			data	= {
				filters : data,
				params : params,
				order_by : _this.appModel._info.sort_by(),
				report_code : reportCode
			};

			_this.appModel.show_group_by(false);
			switch(data.report_code)
			{
				case REPORT_CODE_TIME_SUMMARY:
				case REPORT_CODE_TIME_DETAIL:
					_this.appModel.show_group_by(true);
					if(_this.appModel._info.group_by() == '')
						_this.appModel._info.group_by(GROUP_BY_DATE);

					if(data.report_code==REPORT_CODE_TIME_SUMMARY)
						data.list_view = _this.appModel._info.list_view();

					data.group_by = _this.appModel._info.group_by();
				break;
				case REPORT_CODE_TASK_MILESTONE:
				case REPORT_CODE_TASK_DETAIL:
					data.group_by	= GROUP_BY_PROJECT_TASK;
				case REPORT_CODE_TASK_SUMMARY:
					_this.appModel._info.group_by(GROUP_BY_PROJECT_TASK);
					var fil_tmp = _this.appModel._info.filters();
					if (arg_params.PK!=undefined) {
						if (!fil_tmp.PK) {
							fil_tmp.PK = Otime.o("");
						}
						data.PK = arg_params.PK;
						fil_tmp.PK(arg_params.PK);
					}
					_this.appModel._info.filters(fil_tmp);
					/*if (data.report_code!=REPORT_CODE_TASK_SUMMARY) {
						if (arg_params.PK!=undefined) {
							data.PK = arg_params.PK;
							var fil_tmp = _this.appModel._info.filters()
							fil_tmp.PK = Otime.o(arg_params.PK);
							_this.appModel._info.filters(fil_tmp);
							delete arg_params.PK;
						} else if(_this.appModel._info.filters().PK) {
							data.PK = _this.appModel._info.filters().PK;
						}
						Otime.Menu.ReplaceURL(_this.name + "/task/" +($.isFunction(data.PK)?data.PK():data.PK));
					} else {
						var sld_arr	= _this.appModel._info.filters_history();
						sld_arr[_this.appModel._info.report_code()]	= [];
						_this.appModel._info.filters_history(sld_arr);

						data.PK = '';
						var fil_tmp = _this.appModel._info.filters()
						fil_tmp.PK = Otime.o('');
						_this.appModel._info.filters(fil_tmp);
						Otime.Menu.ReplaceURL(_this.name + "/task/");
					}*/
					data.group_by	= (data.report_code==REPORT_CODE_TASK_DETAIL)?data.group_by:_this.appModel._info.group_by();
				break;	
				case REPORT_CODE_INVOICE_SUMMARY:
					_this.appModel.show_group_by(true);
					if(_this.appModel._info.group_by() == '')
						_this.appModel._info.group_by(GROUP_BY_CLIENT);
					data.group_by	= _this.appModel._info.group_by();
					if(data.report_code == REPORT_CODE_INVOICE_SUMMARY)
						data.list_view = _this.appModel._info.list_view();
				break;
				case REPORT_CODE_INVOICE_DETAIL:
					_this.appModel._info.group_by(GROUP_BY_INVOICE_PERIOD);
					data.group_by	= _this.appModel._info.group_by();
					if(data.report_code == REPORT_CODE_INVOICE_SUMMARY)
						data.list_view = _this.appModel._info.list_view();
				break;
				case REPORT_CODE_INVOICE_AGGING:
					data.interval = _this.appModel._info.interval();
				break;	
				case REPORT_CODE_INVOICE_OUTSTANDING:
					_this.appModel._info.group_by(GROUP_BY_CLIENT);
					data.group_by = _this.appModel._info.group_by();
					data.interval = _this.appModel._info.interval();
				break;	
				case REPORT_CODE_INVOICE_UNINVOICED:
				case REPORT_CODE_BUDGET:
					_this.appModel._info.group_by(GROUP_BY_PROJECT);
					data.group_by = _this.appModel._info.group_by();
					data.budget_type = _this.appModel._info.budget_type();
				break;	
				case REPORT_CODE_BUDGET_DETAIL:
					_this.appModel._info.group_by(GROUP_BY_TASK_TYPE);
					data.group_by = _this.appModel._info.group_by();
				break;
				case REPORT_CODE_EXPENSES_SUMMARY:
				case REPORT_CODE_EXPENSES_DETAIL:
					if(_this.appModel._info.group_by()=='')
						_this.appModel._info.group_by(GROUP_BY_EXPENSES_PERIOD);

					data.group_by = _this.appModel._info.group_by();
					_this.appModel.show_group_by(true);
					
					if(data.report_code==REPORT_CODE_EXPENSES_SUMMARY)
						data.list_view = _this.appModel._info.list_view();
				break;
			}

			_this.appModel.show_view(false);
			if(_this.appModel._info.report_code()==REPORT_CODE_TIME || _this.appModel._info.report_code()==REPORT_CODE_TASK_DETAIL || _this.appModel._info.report_code()==REPORT_CODE_TASK || _this.appModel._info.report_code()==REPORT_CODE_INVOICE || _this.appModel._info.report_code()==REPORT_CODE_EXPENSES)
				_this.appModel.show_view(true);

			_this.appModel._info.params({});
			_this.prepareLink();
			var url = "info" + type;
			Otime.app.loadData(new Otime.ContextModel(url, data, function(cont){
				_this.appModel.loading(false);

				var responseTime	= new Date().getTime();

				if (type != '')
				{
					$('#iframe_download').attr('src',Otime.siteUrl + '/report/download/'+cont.response.file);
					return true;
				}

				if (cont.response && Object.keys(cont.response).length > 0)
				{
					ko.cleanNode($("#report-list-table").get(0));
					//$(".chosen-container", _this.list_container).remove();
					$("#report-list-table").html('');
					cont.response.group_by	= data.group_by;
					cont.response.view		= _this.appModel._info.view();
					
					_this.appModel._info.clients([]);
					_this.appModel._info.projects([]);
					_this.appModel._info.users([]);
					if (cont.response.load_filters)
					{
						if (cont.response.load_filters.clients) {
							cont.response.load_filters.clients.splice(0,0,{client_name:'All Clients', client_id:'all'});
							_this.appModel._info.clients(cont.response.load_filters.clients);
						}
						if (cont.response.load_filters.projects) {
							cont.response.load_filters.projects.splice(0,0,{project_name:'All Projects', project_id:'all'});
							_this.appModel._info.projects(cont.response.load_filters.projects);
						}
						
						if (cont.response.load_filters.users) {
							cont.response.load_filters.users.splice(0,0,{first_name:'All users', user_id:'all'});
							_this.appModel._info.users(cont.response.load_filters.users);
						}
					}

					
					_this.ApplyReport(cont.response);

					_this.buildTemplate(_this.appModel.columns());

//					ko.renderTemplate("tableTmpl", _this.appModel, {
//						afterRender: function(renderedElement) {
//							console.log("rendered!");
//						}
//					}, $("#report-list-table").get(0));
					ko.renderTemplate("tableTmpl", _this.appModel, {}, $("#report-list-table").get(0));
				}
				else
				{
					console.log("No Data");
				}
var endTime	= new Date().getTime();
console.log("Ajax Elapsed : ", (responseTime-startTime)/1000);
console.log("Resp Elapsed : ", (endTime-responseTime)/1000);
console.log("Total Elapsed : ", (endTime-startTime)/1000);
			}));
		};

		var tmpAppModel	= Otime.o(null);

		_this.Bookmark	= {
			data: null,
			get: function(){
				var ret	= JSON.parse(ko.toJSON(_this.appModel._info.filters()));
				ret.page	= "Report";
//				ret.from_date	= new Date(_this.appModel.date_filter.from_date()).format(Otime.sdf);
//				ret.to_date	= new Date(_this.appModel.date_filter.to_date()).format(Otime.sdf);
				ret.date_filter_type	= _this.appModel._info.date_filter_type();
				ret.view		= _this.appModel._info.view();
				ret.report_code	= _this.appModel._info.report_code();
				ret.group_by	= _this.appModel._info.group_by();
				ret.sort_by	= _this.appModel._info.sort_by();
				ret.outstanding	= _this.appModel._info.outstanding();

				delete ret._info;

				return ret;
			},
			set: function(data){
				data	= data || {};

				// stop calling reload fn again while change _this.appModel._info.view subscribe 
				_this.appModel._info.view(data.view || _this.appModel._info.view());
				_this.appModel._info.sort_by(data.sort_by || _this.appModel._info.sort_by());
				_this.appModel._info.report_code(data.report_code || _this.appModel._info.report_code());
				_this.appModel._info.group_by(data.group_by || _this.appModel._info.group_by());
				_this.appModel._info.outstanding(data.outstanding || _this.appModel._info.outstanding());

				var filt	= _this.appModel._info.filters();
				filt.CL(data.CL || Otime.Storage.get("report_filter_CL").split(","));
				filt.PR(data.PR || Otime.Storage.get("report_filter_PR").split(","));
				filt.TT(data.TT || Otime.Storage.get("report_filter_TT").split(","));
				filt.US(data.US || Otime.Storage.get("report_filter_US").split(","));

				if (data.IT)
					filt.IT(data.IT || Otime.Storage.get("report_filter_IT").split(","));
				if (data.EC)
					filt.EC(data.EC || Otime.Storage.get("report_filter_EC").split(","));

				_this.appModel.date_filter.applyDFT(data.date_filter_type || _this.dft || "TW");
			}
		};

		_this.buildTemplate	= function(columns){
			var headTmpl	= '',
				bodyTmpl	= '',
				reportTmpl	= '';

			var allign	= {NC:"ar", N:"ar", S:"al", D:"al", C:"ar", B:"ac"};
	
			var _app_info	= _this.appModel._info;
			var reportCode	= _app_info.report_code(),
				reportView	= _app_info.view(),
				groupBy		= _app_info.group_by();

			headTmpl	+= '<thead class="float">';
			if(reportCode == REPORT_CODE_INVOICE && reportView == VIEW_AGGING)
				headTmpl	+= '<tr class="bb">';
			else
				headTmpl	+= '<tr>';

	
			bodyTmpl	+= '<tbody class="tbdy ac" data-bind="foreach:{data:listing, as:\'item\'}">';
			
			if(reportCode==REPORT_CODE_INVOICE && reportView == VIEW_AGGING)
				bodyTmpl	+= '<tr class="nbt">';
			else
				bodyTmpl	+= '<tr>';
			reportTmpl	+= '<tr data-bind="css:{\'group_by\':item.details!=undefined}">';
	
			if (reportCode == REPORT_CODE_INVOICE && reportView == VIEW_UNINVOICED)
			{
				headTmpl	+= '<th class="col-md-1 al">';
				headTmpl	+= '	<label>&nbsp;</label>';
				headTmpl	+= '</th>';
			}
	
			if(reportCode==REPORT_CODE_INVOICE && reportView==VIEW_UNINVOICED)
			{
				bodyTmpl	+= '<td>';
				bodyTmpl	+= '	<input type="checkbox" data-bind="attr: {value: item[\'CD\']+\'_\'+item[\'PD\']+\'_\'+item[\'PR\']}, checked:$root.itemsChecked">';
				bodyTmpl	+= '</td>';
			}

			$.each(columns, function(key, obj){
				if (groupBy == obj.name && reportView == VIEW_DETAIL)
				{
					return true;
				}

				if (obj.visible && (obj.left_col_visible || reportView == VIEW_AGGING))
				{
					if (reportCode == REPORT_CODE_INVOICE && reportView == VIEW_AGGING)
					{
						headTmpl	+= '<th class="cp sort ' + (allign[obj.type] || 'al') + '">';
						headTmpl	+= '	<span data-bind="click:sort(\'' + obj.name + '\'), css:{\'asc\':(_info.sort_by()==\''+obj.name+'\' && _info.is_asc()), \'desc\':(_info.sort_by()==\''+obj.name+'\' && !_info.is_asc())}">' + obj.label + '</span>';
						headTmpl	+= '</th>';
					}
					else
					{
						headTmpl	+= '<th class="cp sort ' + (allign[obj.type] || 'al') + '">';
						headTmpl	+= '	<span data-bind="click:sort(\'' + obj.name + '\'), ">';
						headTmpl	+= obj.label + '<!-- ko if:_info.sort_by()==\''+obj.name+'\' --> <i data-bind="css:{\'icon-caret-down\':_info.is_asc, \'icon-caret-up\':!_info.is_asc()}"></i><!-- /ko -->';
						headTmpl	+= '	</span>';
//						<span data-bind="click:$parent.sort">
//						</span>

						if ((obj.name == GROUP_BY_INVOICE_PERIOD || obj.name == GROUP_BY_EXPENSES_PERIOD || obj.name == GROUP_BY_DATE) && reportCode == VIEW_SUMMARY && (reportCode() == REPORT_CODE_TIME || reportCode() == REPORT_CODE_INVOICE || reportCode() == REPORT_CODE_EXPENSES))
						{
							headTmpl	+= '<div>';
							headTmpl	+= '	<div class="form-group">';
							headTmpl	+= '		<a href="javascript:;" data-bind="css:{\'active\':_info.list_view()==\'date\'}, click:setListView(\'date\')"><img class="day-icon" src="/assets/img/day_calendar.jpeg" height="16" width="17" style="margin-bottom:3px;" title="Day" /></a>';
							headTmpl	+= '		<a href="javascript:;" data-bind="css:{\'active\':_info.list_view()==\'week\'}, click:setListView(\'week\')"><img class="day-icon" src="/assets/img/week_calendar.png" height="15" width="13" style="margin-bottom:3px;" title="Week" /></a>';
							headTmpl	+= '		<a href="javascript:;" data-bind="css:{\'active\':_info.list_view()==\'month\'}, click:setListView(\'month\')"><i class="day-icon icon-calendar" title="Month" ></i></a>';
							headTmpl	+= '	</div>';
							headTmpl	+= '</div>';
						}
	
						headTmpl	+= '</th>';
					}
	
					if (reportCode==REPORT_CODE_BUDGET || reportCode==REPORT_CODE_BUDGET_DETAIL)
					{
						bodyTmpl	+= '<td class="'+allign[obj.type]+ ' ' + obj.type + '">';
						if (obj.name == REPORT_CODE_BUDGET)
						{
//							bodyTmpl	+= '<a data-bind="click:$root.budget_detail">';
							bodyTmpl	+= '<a data-bind="click:$root.navigateReport" obj="BU">';
							bodyTmpl	+= '	<span class="text-primary cp" data-bind="html:item.' + obj.name + ' + (item.BT==\'A\'?\' '+Otime.Currency+'\':\' hrs\')"></span>';
							bodyTmpl	+= '</a>';
						}
						else if(obj.name == REPORT_CODE_ACTUAL || obj.name == REPORT_CODE_ESTIMATED_HOURS || obj.name == REPORT_CODE_ACTUAL_HOURS)
						{
							/*if (obj.name == REPORT_CODE_ACTUAL_HOURS)
							{
								bodyTmpl	+= '<span class="text-primary cp" data-bind="html:item.' + obj.name + ' + (item.BT==\'A\'?\' '+Otime.Currency+'\':\' hrs\'), click:$root.navigateReport"></span>';
							}
							else
							{*/
								bodyTmpl	+= '<span data-bind="html:item.' + obj.name + ' + (item.BT==\'A\'?\' '+Otime.Currency+'\':\' hrs\')"></span>';
							//}
						}
						else
						{
							bodyTmpl	+= '<span data-bind="date:{date:item.' + obj.name + ',type:\''+obj.type+'\'}"></span>';
						}
						bodyTmpl	+= '</td>';
					}
					else if(reportCode == REPORT_CODE_INVOICE && reportView == VIEW_AGGING)
					{
						bodyTmpl	+= '<td class="' + allign[obj.type] + ' ' + obj.type + '">';
						if (obj.name == GROUP_BY_CLIENT)
						{
							bodyTmpl	+= '<span data-bind="text:item.CL"></span>';
						}
						else
						{
							bodyTmpl	+= '<span class="text-primary cp" data-bind="html:Otime.Report.Currency[item.CC].currency_symbol + \' \' + item.' + obj.name + ', click:function(){$root.agingDetail(\'' + obj.name + '\', item.CN, item.CC)}"></span>';
						}
						bodyTmpl	+= '</td>';
					}
					else if(reportCode == REPORT_CODE_INVOICE && reportView == VIEW_UNINVOICED)
					{
						bodyTmpl	+= '<td class="'+allign[obj.type]+ ' ' + obj.type + '">';
						if (obj.type == DATA_TYPE_CURRENCY)
						{
							bodyTmpl	+= '<span class="' + (obj.name == EXPENSES_UNAPPROVED?'text-primary':'') + '" data-bind="html:\''+Otime.Currency+' \' + item.' + obj.name + '"></span>';
						}
						else if(obj.name == HOURS_UNAPPROVED)
						{
							bodyTmpl	+= '<span class="text-primary" data-bind="text:item.' + obj.name + '"></span>';
							bodyTmpl	+= '<ul class="dropdown-menu controls" data-bind="visible:item.' + obj.name + '>0" >';
							bodyTmpl	+= '	<li class="dropdown pull-left">';
							bodyTmpl	+= '		<a class="cp" data-bind="click:function(){$root.uninvoice_view(item.PD, item.CD, \'O\')}">';
							bodyTmpl	+= '			<span>View</span>';
							bodyTmpl	+= '		</a>';
							bodyTmpl	+= '	</li>';
							bodyTmpl	+= '	<li class="pull-left">|</li>';
							bodyTmpl	+= '	<li class="dropdown pull-left">';
							bodyTmpl	+= '		<a class="cp" data-bind="click:function(){$root.approve_hours(item.PD, item.CD)}">';
							bodyTmpl	+= '			<span>Approve</span>';
							bodyTmpl	+= '		</a>';
							bodyTmpl	+= '	</li>';
							bodyTmpl	+= '</ul>';
						}
						else if (obj.name == EXPENSES_UNAPPROVED)
						{
							bodyTmpl	+= '<ul class="dropdown-menu controls" data-bind="visible:item.' + obj.name + '>0" >';
							bodyTmpl	+= '	<li class="dropdown pull-left">';
							bodyTmpl	+= '		<a class="cp" data-bind="click:function(){$root.uninvoice_view(item.PD, item.CD, \'E\')}">';
							bodyTmpl	+= '			<span>View</span>';
							bodyTmpl	+= '		</a>';
							bodyTmpl	+= '	</li>';
							bodyTmpl	+= '	<li class="pull-left">|</li>';
							bodyTmpl	+= '	<li class="dropdown pull-left">';
							bodyTmpl	+= '		<a class="cp" data-bind="click:function(){$root.approve_expenses(item.PD, item.CD)}">';
							bodyTmpl	+= '			<span>Approve</span>';
							bodyTmpl	+= '		</a>';
							bodyTmpl	+= '	</li>';
							bodyTmpl	+= '</ul>';
						}
						else
						{
							bodyTmpl	+= '<span data-bind="text:item.' + obj.name + '"></span>';
						}
						bodyTmpl	+= '</td>';
					}
					else
					{
						bodyTmpl	= '<tbody class="tbdy ac" data-bind="template:{name:\'lstTmpl\', foreach:listing, as:\'item\'}">';
						bodyTmpl	+= '</tbody>';

						if (obj.name == "FH")
						{
							reportTmpl	+= '<td data-bind="css:{\'over-due\':item.OD}" class="' + allign[obj.type] + ' ' + obj.type + '">';
						}
						else
						{
							reportTmpl	+= '<td class="' + allign[obj.type] + ' ' + obj.type + '">';
						}

						if (obj.type == DATA_TYPE_CURRENCY)
						{
							reportTmpl	+= '<span class="'+(obj.name == EXPENSES_UNAPPROVED ? "text-primary" : "")+'">' + Otime.Currency + ' <!-- ko text:item.' + obj.name + ' --><!-- /ko --></span>';
						}
//						else if (obj.type == VIEW_DETAIL && obj.name != GROUP_BY_INVOICE_PERIOD && obj.name != GROUP_BY_EXPENSES_PERIOD)
//						{
//							reportTmpl	+= '<span data-bind="date:{date:item.' + obj.name + '}"></span>';
//						}
						else if (obj.name == "PC" && obj.type == DATA_TYPE_NUMBER)
						{
							reportTmpl	+= '<div class="progress">';
							reportTmpl	+= '	<div class="progress-bar progress-bar-success" role="progressbar" aria-valuemin="0" aria-valuemax="100" data-bind="attr:{\'aria-valuenow\':item.' + obj.name + '}, style:{width:item.' + obj.name + '+\'%\'}">';
							reportTmpl	+= '		<span style="color:#000000;padding-left:17px;" data-bind="text:item.' + obj.name + ' + \'%\'"></span>';
							reportTmpl	+= '	</div>';
							reportTmpl	+= '</div>';
						}
						else
						{
console.log('reportCode ==>', reportView);
							if (obj.name == GROUP_BY_INVOICE_STATUS)
							{
								reportTmpl	+= '<span><button class="btn" data-bind="attr:{class:\'btn btn-sm \'+ item.' + obj.name + '_class_name} , text:item.' + obj.name + '"></button></span>';
							}
							else if (obj.name == "SS")
							{
								reportTmpl	+= '<span class="label status" data-bind="text:item.' + obj.name + ', style:{backgroundColor:item.SB, color:item.SX}"></span>';
							}
							else if (obj.name == "DA" && reportCode == REPORT_CODE_TASK && reportView == "D")
							{
								reportTmpl	+= '<span class="label status" data-bind="visible:item.details!=undefined, text:item.' + obj.name + ', style:{backgroundColor:item.SB, color:item.SX}"></span>';
								reportTmpl	+= '<span obj="' + obj.name + '" data-bind="visible:item.details==undefined, date:{date:item.' + obj.name + ',type:\''+obj.type+'\'}, click:$root.navigateReport"></span>';
							}
							else if ((reportCode == REPORT_CODE_TIME || reportCode == REPORT_CODE_EXPENSES) && obj.name == groupBy)
							{
								reportTmpl	+= '<span class="text-primary cp" obj="' + obj.name + '" data-bind="date:{date:item.' + obj.name + ',type:\''+obj.type+'\'}, click:$root.navigateReport"></span>';
							}
							else if (reportCode == REPORT_CODE_TASK && (reportView == "S" || reportView == "M" || reportView == "D") && (obj.name == "TH" || obj.name == "WH" || obj.name == "ER"))
							{
								// reportTmpl	+= '<span class="text-primary cp" obj="' + obj.name + '" data-bind="date:{date:item.' + obj.name + ',type:\''+obj.type+'\'}, click:$root.navigateReport"></span>';
								if (obj.name == "WH") {
									reportTmpl	+= '<span class="text-primary cp" obj="' + obj.name + '" data-bind="hours:{val:' + obj.name + '}, click:$root.navigateReport"></span>';
								} else {
									reportTmpl	+= '<span obj="' + obj.name + '" data-bind="hours:{val:' + obj.name + '}"></span>';
								}
							}
							else
							{
//console.log(obj.type, obj.name, groupBy);
								if(REPORT_CODE_INVOICE == reportCode && "O" == reportView && (REPORT_CODE_OUTSTANDING == obj.name))
								{
									reportTmpl	+= '<span class="text-primary cp" data-bind="html:Otime.Report.Currency[item.CC].currency_symbol + \' \' + item.' + obj.name + ', click:$root.invoiceDetail"></span>';
								}
								else if (DATA_TYPE_DATE == obj.type || GROUP_BY_DATE == groupBy || GROUP_BY_EXPENSES_PERIOD == groupBy || INVOICE_AMOUNT == obj.name || PAYMENT_AMOUNT == obj.name)
								{
									reportTmpl	+= '<span data-bind="date:{date:item.' + obj.name + ',type:\''+obj.type+'\'}"></span>';
								}
								else
								{
//									reportTmpl	+= '<span data-bind="text:item.' + obj.name + '"></span>';
									reportTmpl	+= '<span data-bind="text:item.' + obj.name + '"></span>';
								}
							}
						}
						reportTmpl	+= '</td>';
					}
				}
			});
	
			reportTmpl	+= '</tr>';
			reportTmpl	+= '<!-- ko if:item.details && item.details().length>0 -->';
			reportTmpl	+= '<!-- ko template:{ name:\'lstTmpl\', foreach:item.details, as:\'item\'} --><!-- /ko -->';
			reportTmpl	+= '<!-- /ko -->';
	
			bodyTmpl	+= '	</tr>';
			bodyTmpl	+= '</tbody>';

			headTmpl	+= '	</tr>';
			headTmpl	+= '</thead>';

//			$("#report-list-table").html(headTmpl + bodyTmpl);
			$("#tableTmpl").html(headTmpl + bodyTmpl);
			$("#lstTmpl").html(reportTmpl);
//			$("#lstTmpl").get(0).innerHtml	= reportTmpl;

//			return headTmpl + bodyTmpl;
			return $("#report-list-table");
		};

		_this.UpdateContainers	= function(){
			_this.list_container	= $("#report-container");
			_this.view_container	= $("#view-layout");
			_this.edit_container	= $("#view-layout");
			_this.add_container		= $("#view-layout");
		};

		_this.init	= function(){
			_this.UpdateContainers();
			Otime.unbind();

			var data	= _this.Bookmark.data || {};

			_this.appModel = new _this.ReportModel({
				view: data.rv || data.view,
				sort_by: data.sb || data.sort_by,
				report_code: data.rc || data.report_code,
				group_by: data.gb|| data.group_by,
				outstanding: data.outstanding
			});
			Otime.app.model	= _this.appModel;

			_this.appModel._info.filters(new _this.Filters({
				CL : data.CL || (Otime.Storage.get("report_filter_CL") || "all").split(","),
				PR : data.PR || (Otime.Storage.get("report_filter_PR") || "all").split(","),
				TT : data.TT || (Otime.Storage.get("report_filter_TT") || "all").split(","),
				US : data.US || (Otime.Storage.get("report_filter_US") || "all").split(","),
				IT : data.IT || (Otime.Storage.get("report_filter_IT") || "all").split(","),
				EC : data.EC || (Otime.Storage.get("report_filter_EC") || "all").split(","),
				TKS : data.TKS || (Otime.Storage.get("report_filter_TKS") || "all").split(",")
			}));
			var dft  = data.dt_ty || data.date_filter_type || _this.dft || DATE_FILTER_THIS_WEEK;
			if (dft=='CU' && data.fd && data.td) {
				_this.appModel.date_filter.from_date(new Date(data.fd).format(Otime.jdf));
				_this.appModel.date_filter.to_date(new Date(data.td).format(Otime.jdf));
			}
			_this.appModel.date_filter.applyDFT(dft);

			tmpAppModel(_this.appModel);
			ko.applyBindings(tmpAppModel, this.list_container.get(0));
		};
	};
}(window.Otime));
